/*
rushhour.cpp
main game functions ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/




#include "stdafx.h"

#include "globals.h"



BOOL overlight = 0;
int overlightmapx = 0;
int overlightmapy = 0;

BOOL song0playing = FALSE;
BOOL song1playing = FALSE;
BOOL song2playing = FALSE;
BOOL song3playing = FALSE;

MUSIC_TIME		startmusictime;

MUSIC_TIME		musictimelength0;
MUSIC_TIME		musictimelength1;
MUSIC_TIME		musictimelength2;
MUSIC_TIME		musictimelength3;




short int checkat[41] = {
	74,64,55,47,40,34,29,25,22,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,4,3,3,3,2,2,2,2,1,1,1,1,1,1,0
};


DWORD checkfornewcarat = 0L;


/*
int olddrawcitymap( void )
{


	word *tempscreenptr;
	word *tempscreenptr2;

	int gridx, gridy;

	int bitindex, lineindex;

	word *picptr;

	int sectionno;

	byte xsize, ysize;

	byte color;


//sprintf( debugstr, "Entering drawcitymap() ...\n" );
//WRITETODEBUGFILE;


// Put default green ...
	tempscreenptr = citymapgraphicptr;

		for( bitindex = 0; bitindex < SCREENHEIGHT * SCREENHEIGHT; bitindex++ )
		{
			switch( rand()%6 )
			{
			case 0:
			case 1:
			case 2:
			case 3:
				color = 192; break;
			case 4:
				color = 224; break;
			case 5:
				color = 224; break;

			} // end find color

#ifdef EDITORS
			if( (gamescreen == GS_EDITMAP) || (gamescreen == GS_MAKEPATH) ) color = 192;
#endif

			*tempscreenptr = color;
			tempscreenptr++;
		} // end bitindex loop




// Draw Grid graphics ...

	tempscreenptr = citymapgraphicptr;

	for( gridy = 0; gridy < GRIDWIDTH; gridy++ )
	{
		for( gridx = 0; gridx < GRIDWIDTH; gridx++ )
		{
			tempscreenptr2 = tempscreenptr;

// TESTES ! TODO -- Change MULT to Shift
			sectionno = citymap[ (gridy*GRIDWIDTH) + gridx ];

			if( !sectionno )
			{
				tempscreenptr += GRIDSIZE;
				continue;
			} // end if nothing here ...

//			picptr = sectionsptr + times640(citysection[sectionno].graphicy) + citysection[sectionno].graphicx;

			xsize = citysection[sectionno].xsize;
			ysize = citysection[sectionno].ysize;

			
			for( lineindex = 0; lineindex < GRIDSIZE*ysize; lineindex++ )
			{
// TODO -- Redo in ASM to use dwords ...
				for( bitindex = 0; bitindex < GRIDSIZE*xsize; bitindex++ )
				{
					if( *picptr ) *tempscreenptr2 = *picptr;

					picptr++;
					tempscreenptr2++;
				} // end bitindex loop

				picptr += 640L - GRIDSIZE*xsize;
				tempscreenptr2 += SCREENHEIGHT - GRIDSIZE*xsize;

			} // end lineindex loop


			tempscreenptr += GRIDSIZE;
		} // end gridx loop

// TODO -- Take out MULT		
		tempscreenptr += (GRIDSIZE-1) * SCREENHEIGHT;
	} // end gridy loop


#ifdef EDITORS
	if( (gamescreen == GS_EDITMAP) && gridon )
	{
		gridx = 0;
		for( gridy = 0; gridy < SCREENHEIGHT; gridy += 20 )
		{
// TODO -- Take out MULT		
			tempscreenptr = citymapgraphicptr + (gridy*SCREENHEIGHT) + gridx;

			for( lineindex = 0; lineindex < SCREENHEIGHT; lineindex+=2 )
			{
				*tempscreenptr = 0;
				tempscreenptr += 2L;
			} // end lineindex loop

		} // end gridy loop

		gridy = 0;
		for( gridx = 200; gridx < SCREENWIDTH; gridx += 20 )
		{
// TODO -- Take out MULT		
			tempscreenptr = citymapgraphicptr + (gridy*SCREENHEIGHT) + gridx;

			for( lineindex = 0; lineindex < SCREENHEIGHT; lineindex+=2 )
			{
				*tempscreenptr = 0;
				tempscreenptr += SCREENHEIGHT*2L;
			}
		} // end gridy loop

	} // end if showing grid
#endif

	copycitygraphic();



//sprintf( debugstr, "Exiting drawcitymap() ...\n" );
//WRITETODEBUGFILE;

	return TRUE;

} // end olddrawcitymap
*/


int drawcitymap( void )
{
	int gridx, gridy;
	word *picptr, *tempptr;
	int totalmem;

	int sectionno;
	byte xsize, ysize;

	HRESULT ddrval;
	DDSURFACEDESC2 ddsd;
	RECT rcRect, rcRect2;

//	DDBLTFX ddbltfx;


// For rotation ...
	word *srcptr;
	word *destptr;
	int srcx, srcy;
	int destx, desty;
	int width, height;

	byte isflipped;
	byte rotation;


/*
// Put default green ...
	tempscreenptr = citymapgraphicptr;

		for( bitindex = 0; bitindex < SCREENHEIGHT * SCREENHEIGHT; bitindex++ )
		{
			switch( rand()%6 )
			{
			case 0:
			case 1:
			case 2:
			case 3:
				color = 192; break;
			case 4:
				color = 224; break;
			case 5:
				color = 224; break;

			} // end find color

#ifdef EDITORS
			if( (gamescreen == GS_EDITMAP) || (gamescreen == GS_MAKEPATH) ) color = 192;
#endif

			*tempscreenptr = color;
			tempscreenptr++;
		} // end bitindex loop

*/

// Put Background ....
/*
		memset( &ddsd, 0, sizeof(ddsd) );
		ddsd.dwSize = sizeof(ddsd);
		
		ddrval = DDERR_WASSTILLDRAWING;
		
		while( ddrval == DDERR_WASSTILLDRAWING )
		{
			ddrval = lpDDS[DDS_CITYMAP]->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR, NULL );
		}

		if( ddrval != DD_OK )
		{
			ShowDDError("Lock()", ddrval);
			cleanup( MISC, "Couldn't Lock() City Map Surface!" );
		}
		
		picptr = (word *)ddsd.lpSurface;

		totalmem = (ddsd.lPitch * 600L) >> 1;

		for( tempptr = picptr; tempptr < picptr+totalmem; tempptr++ )
		{
			*tempptr = 256L;
		} // end make green loop
*/




	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = 600;
	rcRect.bottom = 600;


    while( 1 )
    {
        ddrval = lpDDS[DDS_CITYMAP]->BltFast( 0, 0, lpDDS[DDS_GROUND],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}


		





// Draw Grid graphics ...

	for( gridy = 0; gridy < GRIDWIDTH; gridy++ )
	{
		for( gridx = 0; gridx < GRIDWIDTH; gridx++ )
		{

// TESTES ! TODO -- Change MULT to Shift
			sectionno = citymap[ (gridy*GRIDWIDTH) + gridx ];

			if( !sectionno )
			{
				continue;
			} // end if nothing here ...

			rcRect.left = citysection[sectionno].graphicx;
			rcRect.top  = citysection[sectionno].graphicy;

			xsize = citysection[sectionno].xsize;
			ysize = citysection[sectionno].ysize;

			rcRect.right  = rcRect.left + (xsize * GRIDSIZE);
			rcRect.bottom = rcRect.top  + (ysize * GRIDSIZE);

			rcRect2.left = gridx * GRIDSIZE;
			rcRect2.top = gridy * GRIDSIZE;
			rcRect2.right = rcRect2.left + (xsize * GRIDSIZE);
			rcRect2.bottom = rcRect2.top + (ysize * GRIDSIZE);



//	ZeroMemory( &ddbltfx, sizeof(DDBLTFX) );
//	ddbltfx.dwSize = sizeof( DDBLTFX );


// Rotate if needed ...
	rotation = rotationmap[(gridy*GRIDWIDTH) + gridx] & 127;
	isflipped = rotationmap[(gridy*GRIDWIDTH) + gridx] & 128;
	
	if( rotation || isflipped )
	{
		memset( &ddsd, 0, sizeof(ddsd) );
		ddsd.dwSize = sizeof(ddsd);
		
		ddrval = DDERR_WASSTILLDRAWING;
		
		while( ddrval == DDERR_WASSTILLDRAWING )
		{
			ddrval = lpDDS[DDS_SECTIONS]->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR, NULL );
		}

		if( ddrval != DD_OK )
		{
			ShowDDError("Lock()", ddrval);
			cleanup( MISC, "Couldn't Lock() Sections Surface!" );
		}
		
		srcptr = (word *)ddsd.lpSurface + rcRect.left + (rcRect.top * 640L);


		width = times20(xsize);
		height = times20(ysize);

		switch( rotation )
		{
		case 0:
			for( srcy = 0; srcy < height; srcy++ )
			{
				for( srcx = 0; srcx < width; srcx++ )
				{
					desty = srcy;
					destx = (width-srcx-1);

					destptr = (word *)ddsd.lpSurface + (560L+(560L*640L)) +
						destx + (desty * 640L);

					*destptr = *srcptr;

					srcptr++;
				} // end srcx loop

				srcptr += 640L - width;
			} // end srcy loop

			break; // end case no rotation but IS flipped

		case 1:
			for( srcy = 0; srcy < height; srcy++ )
			{
				for( srcx = 0; srcx < width; srcx++ )
				{
					if( isflipped )
					{
						desty = (width-srcx-1);
						destx = (height-srcy-1);
					}
					else
					{
						desty = srcx;
						destx = (height-srcy-1);
					}

					destptr = (word *)ddsd.lpSurface + (560L+(560L*640L)) +
						destx + (desty * 640L);

					*destptr = *srcptr;

					srcptr++;
				} // end srcx loop

				srcptr += 640L - width;
			} // end srcy loop

			break; // end case 90 degrees

		case 2:
			for( srcy = 0; srcy < height; srcy++ )
			{
				for( srcx = 0; srcx < width; srcx++ )
				{
					if( isflipped )
					{
						desty = (height-srcy-1);
						destx = srcx;
					}
					else
					{
						desty = (height-srcy-1);
						destx = (width-srcx-1);
					}

					destptr = (word *)ddsd.lpSurface + (560L+(560L*640L)) +
						destx + (desty * 640L);

					*destptr = *srcptr;

					srcptr++;
				} // end srcx loop

				srcptr += 640L - width;
			} // end srcy loop

			break; // end case 180 degrees

		case 3:
			for( srcy = 0; srcy < height; srcy++ )
			{
				for( srcx = 0; srcx < width; srcx++ )
				{
					if( isflipped )
					{
						desty = srcx;
						destx = srcy;
					}
					else
					{
						desty = (width-srcx-1);
						destx = srcy;
					}

					destptr = (word *)ddsd.lpSurface + (560L+(560L*640L)) +
						destx + (desty * 640L);

					*destptr = *srcptr;

					srcptr++;
				} // end srcx loop

				srcptr += 640L - width;
			} // end srcy loop

			break; // end case 270 degrees

		} // end switch on rotationmap[(gridy*GRIDWIDTH) + gridx]

		rcRect.left = 560;
		rcRect.top = 560;
		rcRect.right = 560 + width;
		rcRect.bottom = 560 + height;

		ddrval = lpDDS[DDS_SECTIONS]->Unlock( NULL );
		if( ddrval != DD_OK )
		{
			ShowDDError("Unlock()", ddrval);
			cleanup( MISC, "Couldn't Unlock() Sections Surface!" );
		}

	} // end if rotated and/or flipped





    while( 1 )
    {
//        ddrval = lpDDS[DDS_CITYMAP]->BltFast( (gridx*GRIDSIZE), (gridy*GRIDSIZE), lpDDS[DDS_SECTIONS],
//            &rcRect, DDBLTFAST_SRCCOLORKEY );
        ddrval = lpDDS[DDS_CITYMAP]->Blt( &rcRect2, lpDDS[DDS_SECTIONS],
            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( MISC, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawcitymap()", ddrval );
			sprintf( tempstr, "(%d,%d) - (%d,%d)", rcRect.left, rcRect.top, rcRect.right, rcRect.bottom );
			cleanup( MISC, tempstr );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}



		} // end gridx loop

	} // end gridy loop


/*

#ifdef EDITORS
	if( (gamescreen == GS_EDITMAP) && gridon )
	{
		gridx = 0;
		for( gridy = 0; gridy < SCREENHEIGHT; gridy += 20 )
		{
// TODO -- Take out MULT		
			tempscreenptr = citymapgraphicptr + (gridy*SCREENHEIGHT) + gridx;

			for( lineindex = 0; lineindex < SCREENHEIGHT; lineindex+=2 )
			{
				*tempscreenptr = 0;
				tempscreenptr += 2L;
			} // end lineindex loop

		} // end gridy loop

		gridy = 0;
		for( gridx = 200; gridx < SCREENWIDTH; gridx += 20 )
		{
// TODO -- Take out MULT		
			tempscreenptr = citymapgraphicptr + (gridy*SCREENHEIGHT) + gridx;

			for( lineindex = 0; lineindex < SCREENHEIGHT; lineindex+=2 )
			{
				*tempscreenptr = 0;
				tempscreenptr += SCREENHEIGHT*2L;
			}
		} // end gridy loop

	} // end if showing grid
#endif

*/


// Draw Interface Bar at Top ...

	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = 600;
	rcRect.bottom = 24;

    while( 1 )
    {
        ddrval = lpDDS[DDS_CITYMAP]->BltFast( 0, 0, lpDDS[DDS_TOPBAR],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDS[DDS_CITYMAP]->Blt( &rcRect2, lpDDS[DDS_SECTIONS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( MISC, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawcitymap()", ddrval );
			sprintf( tempstr, "(%d,%d) - (%d,%d)", rcRect.left, rcRect.top, rcRect.right, rcRect.bottom );
			cleanup( MISC, tempstr );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}



	copycitygraphic();



	return TRUE;

} // end drawcitymap





// Copies city graphic to vscreen ...

int copycitygraphic( void )
{
	HRESULT ddrval;

	RECT rcRect;


	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = 600;
	rcRect.bottom = 600;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 200, 0, lpDDS[DDS_CITYMAP],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in copycitygraphic", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}



/* Old way ... before VRAM surfaces ...

	word *tempscreenptr;
	word *temppicptr;


//sprintf( debugstr, "Entering copycitygraphic() ...\n" );
//WRITETODEBUGFILE;


	LOCKVS;

	tempscreenptr = g_vsptr + VSOFFSET + 200L;
	temppicptr = citymapgraphicptr;

	_asm
	{
		mov edx, SCREENHEIGHT // Number of lines left to draw

		mov edi, tempscreenptr
		mov esi, temppicptr

StartLine:

		mov ecx, SCREENHEIGHT/2
		rep movsd

		add edi, 200*2

		dec edx
		jnz StartLine

	} // end asm block


	UNLOCKVS;


//sprintf( debugstr, "Exiting copycitygraphic() ...\n" );
//WRITETODEBUGFILE;

*/

	return TRUE;

} // end copycitygraphic




// New car will be placed at end of linked list ...
// Returns TRUE is successful, or FALSE if failed ...

int newcar( void )
{
	int index;
	CAR *carptr;
	CAR *prevcarptr;
	CAR *nextcarptr;

	int pathno;
	POSSIBLEPATH *pathptr;


// If no possible paths, FAIL!
	if( city.numofpaths == 0 ) return FALSE;


	carptr = (CAR *)calloc( 1, sizeof(CAR) );
	if( carptr == NULL ) cleanup( OUTOFMEM, "newcar()" );

	memoryused += sizeof(CAR);


	prevcarptr = (CAR *)lastcar.prevcar;
	prevcarptr->nextcar = carptr;

	carptr->nextcar = &lastcar;
	carptr->prevcar = lastcar.prevcar;

	lastcar.prevcar = carptr;


// Initialize car ...
// TODO -- Pick from possible paths ...
StartGetPath:
	pathno = rand()%city.numofpaths;
	pathptr = &possiblepath[pathno];

	if( !pathptr->isused ) goto StartGetPath;

	carptr->carmapx = pathptr->startx;
	carptr->carmapy = pathptr->starty;

	carptr->facing = pathptr->path[0];


// See if this is an emergency vehicle
// TODO -- Take out MOD
	if( (rand()%64) == 0 )
	{
		carptr->speed = 2;
		carptr->carid = AMBULANCE;

		carptr->homex = 420;
		carptr->homey = 0;

		numofcopsonmap++;

	} // end if AMBULANCE

	else
	{
		carptr->speed = 2;
// Choose graphic for car ...
		carptr->carid = rand()%16;

//		carptr->homex = times20(carptr->carid);
// TODO! Take out MULT ...
		carptr->homex = carptr->carid * 20;

		carptr->homey = 0;

	} // end if regular car

// TESTES!! if difficulty == 40 set all car speeds to 1 ...
//	if( difficulty == 40 ) carptr->speed = 1;

		switch( carptr->facing )
		{
		case N:
		carptr->graphicx = 0;
		carptr->graphicy = 10;
		carptr->xsize = 1;
		carptr->ysize = 2;
		break;

		case S:
		carptr->graphicx = 10;
		carptr->graphicy = 10;
		carptr->xsize = 1;
		carptr->ysize = 2;
		break;

		case E:
		carptr->graphicx = 0;
		carptr->graphicy = 30;
		carptr->xsize = 2;
		carptr->ysize = 1;
		break;

		case W:
		carptr->graphicx = 0;
		carptr->graphicy = 0;
		carptr->xsize = 2;
		carptr->ysize = 1;
		break;


		} // end switch on start facing ...




	memcpy( carptr->path, pathptr->path, 256 );

	
	carptr->nextmoveat = tickcount + carptr->speed;

	numofcars++;


// Check for player being fired ... can't place new car ...
// TODO - Take out mult ...
	if( carmap[ (carptr->carmapy * 60) + carptr->carmapx ] == 1 )
	{
		warninglevel += 8;

		numofcars--;
		if( carptr->carid == AMBULANCE ) numofcopsonmap--;

		prevcarptr = (CAR *)carptr->prevcar;
		nextcarptr = (CAR *)carptr->nextcar;

		prevcarptr->nextcar = nextcarptr;
		nextcarptr->prevcar = prevcarptr;

		free( carptr );
		memoryused -= sizeof(CAR);

		return TRUE;

	} // end if car in the way but moving ...


	if( carmap[ (carptr->carmapy * 60) + carptr->carmapx ] == 2 )
	{
		warninglevel += 8;

		numofcars--;
		if( carptr->carid == AMBULANCE ) numofcopsonmap--;

		prevcarptr = (CAR *)carptr->prevcar;
		nextcarptr = (CAR *)carptr->nextcar;

		prevcarptr->nextcar = nextcarptr;
		nextcarptr->prevcar = prevcarptr;

		free( carptr );
		memoryused -= sizeof(CAR);

		return TRUE;

	} // end if car in the way and stopped


	return TRUE;

} // end newcar



// Also updates lights ...
// and checks for crashes ...
int updatecars( void )
{
	int mapx, mapy;
	int oldmapx, oldmapy;
	int csno;	// city section number

	int tempmapx, tempmapy;

	int index;

	CAR *currcar;
	CAR *prevcarptr;
	CAR *nextcarptr;

	int mapspace;

	byte oldfacing;

	byte stopped;

	int carmapx, carmapy;
	int carspace;


// Update traffic lights ...
// Check for waiting ...
// TODO -- Lock in to timer ...
	mapspace = 0;

	for( mapy = 0; mapy < 30; mapy++ )
	{
	for( mapx = 0; mapx < 30; mapx++ )
	{
// Check for light timer ...		
		if( lightwait[mapspace] <= lighttickcount )
		{
			lightwait[mapspace] = 0;

				switch( lightmap[mapspace] )
				{
				case HORZYELLOW:
					lightmap[mapspace] = HORZRED;
					break;
				case VERTYELLOW:
					lightmap[mapspace] = VERTRED;
					break;
				case WRECKATLIGHT:
				case COPATLIGHT:
					if( rand()%2 == 0 )
						lightmap[mapspace] = HORZRED;
					else
						lightmap[mapspace] = VERTRED;
					break;
				} // end switch on which yellow light

		} // end if light is through waiting 



// Check for crash ...
		if( lightmap[mapspace] )
		{
			carmapx = mapx<<1;
			carmapy = mapy<<1;

			carspace = (carmapy*60) + carmapx;

			if( (carmap[carspace]==2) && (carmap[carspace+1]==2) &&
				(carmap[carspace+60]==2) && (carmap[carspace+61]==2) )
			{
// Remove all offending cars ...
				currcar = (CAR *)firstcar.nextcar;

				if( currcar == &lastcar ) goto EndRemoveCars;

// Loop through all available cars ...
				for( ;; )
				{
					if( currcar == &lastcar ) break;

					if( ((currcar->carmapx == carmapx) || (currcar->carmapx == carmapx+1)) &&
						((currcar->carmapy == carmapy) || (currcar->carmapy == carmapy+1)) )
					{
// Remove car from carmap ...
		tempmapx = currcar->carmapx;
		tempmapy = currcar->carmapy;
//		stopped = currcar->stopped + 1;

		switch( currcar->facing )
		{
		case N:
			for( index = 0; index < currcar->ysize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapy >= 60 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = 0;
				tempmapy++;
			} // end index loop
			break;

		case S:
			for( index = 0; index < currcar->ysize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapy < 0 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = 0;
				tempmapy--;
			} // end index loop
			break;

		case E:
			for( index = 0; index < currcar->xsize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapx < 0 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = 0;
				tempmapx--;
			} // end index loop
			break;

		case W:
			for( index = 0; index < currcar->xsize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapx >= 60 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = 0;
				tempmapx++;
			} // end index loop
			break;

		} // end switch on facing

		if( currcar->carid == AMBULANCE )
		{
			numofcopsonmap--;
			numofcopsstopped--;
		}



						prevcarptr = (CAR *)currcar->prevcar;
						nextcarptr = (CAR *)currcar->nextcar;

						prevcarptr->nextcar = nextcarptr;
						nextcarptr->prevcar = prevcarptr;

						free( currcar );
						memoryused -= sizeof(CAR);

						numofcars--;
						numofcarsstopped--;

						currcar = nextcarptr;

						continue;
					} // end if this car is intersection (front check only)

				currcar = (CAR *)currcar->nextcar;
				} // end loop through all cars 

EndRemoveCars:

			if( lightmap[mapspace] != COPATLIGHT )
			{
				lightmap[mapspace] = WRECKATLIGHT;
				lightwait[mapspace] = lighttickcount + 600L;

				if( soundon ) lpdsbuffer[SND_CRASH]->Play( NULL, NULL, NULL );
			}

			} // end if entire intersection filled with stopped cars

		} // end if light here ...

		mapspace++;
	} // end mapx loop

	} // end mapy loop




// These are counted during loop ...	
	numofcopsstopped = 0;


	currcar = (CAR *)firstcar.nextcar;

	if( currcar == &lastcar ) goto EndUpdateCars;

// Loop through all available cars ...
	for( ;; )
	{
		if( currcar == &lastcar ) break;

		if( currcar->stopped && (currcar->carid == AMBULANCE) ) numofcopsstopped++;

		if( tickcount < currcar->nextmoveat )
		{
			currcar = (CAR *)currcar->nextcar;
			continue;
		} // end if car waiting ...

		currcar->nextmoveat = tickcount + currcar->speed;


		if( currcar->spaceshift )
		{
			currcar->spaceshift--;
			currcar = (CAR *)currcar->nextcar;
			continue;
		} // end if currcar->spaceshift



// Move car if possible ...

		oldmapx = mapx = currcar->carmapx;
		oldmapy = mapy = currcar->carmapy;

// Clear old block in carmap ...
		tempmapx = mapx;
		tempmapy = mapy;


		switch( currcar->facing )
		{
		case N:
			for( index = 0; index < currcar->ysize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapy >= 60 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = 0;
				tempmapy++;
			} // end index loop
			break;

		case S:
			for( index = 0; index < currcar->ysize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapy < 0 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = 0;
				tempmapy--;
			} // end index loop
			break;

		case E:
			for( index = 0; index < currcar->xsize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapx < 0 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = 0;
				tempmapx--;
			} // end index loop
			break;

		case W:
			for( index = 0; index < currcar->xsize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapx >= 60 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = 0;
				tempmapx++;
			} // end index loop
			break;

		} // end switch on facing


// Change car facing if needed ...
		oldfacing = currcar->facing;
		currcar->facing = currcar->path[ currcar->pathno ];

	switch( currcar->facing )
	{
	case N:
		currcar->graphicx = 0;
		currcar->graphicy = 10;
		currcar->xsize = 1;
		currcar->ysize = 2;
		break;

	case S:
		currcar->graphicx = 10;
		currcar->graphicy = 10;
		currcar->xsize = 1;
		currcar->ysize = 2;
		break;

	case E:
		currcar->graphicx = 0;
		currcar->graphicy = 30;
		currcar->xsize = 2;
		currcar->ysize = 1;
		break;

	case W:
		currcar->graphicx = 0;
		currcar->graphicy = 0;
		currcar->xsize = 2;
		currcar->ysize = 1;
		break;

	} // end switch on current facing ...



		

		switch( currcar->facing )
		{
		case N:
			mapy--;
			if( currcar->facing != oldfacing )
			{
				mapy--; // if car is turning
				currcar->pathno++;
			}
			break;
		case S:
			mapy++;
			if( currcar->facing != oldfacing ) // if car is turning
			{
				mapy++; // if car is turning
				currcar->pathno++;
			}
			break;
		case W:
			mapx--;
			if( currcar->facing != oldfacing ) // if car is turning
			{
				mapx--; // if car is turning
				currcar->pathno++;
			}
			break;
		case E:
			mapx++;
			if( currcar->facing != oldfacing ) // if car is turning
			{
				mapx++; // if car is turning
				currcar->pathno++;
			}
			break;

		default:
			cleanup( MISC, "Invalid direction!" );
			return FALSE;
		} // end switch on facing


// Check for stoplight ...

// If car is already in intersection, go ahead and go through ... DON'T stop!
		if( lightmap[ ((oldmapy>>1) * 30) + (oldmapx>>1) ] )
			goto CheckForCar;

// TODO -- Take out mult ...
		csno = ((mapy>>1) * 30) + (mapx>>1);

		tempmapy = (csno/30) << 1;
		tempmapx = (csno-((csno/30)*30)) << 1;

//		sprintf( tempstr, "( %d, %d )", tempmapx, tempmapy );
//		centertext( tempstr, 60, 160, 640 );



// Only check if space is ON map!
		if( (mapx >= 0) && (mapx < 60) && (mapy >= 0) && (mapy < 60) )
		{


		if( lightmap[csno] )
		{
			switch( lightmap[csno] )
			{
			case WRECKATLIGHT:
				mapx = oldmapx;
				mapy = oldmapy;
				break; // No cars go through

			case COPATLIGHT:
				break;	// All cars go through

			case VERTYELLOW:
			case HORZRED:
				if( currcar->carid == AMBULANCE ) break;

				if( (currcar->facing == E) || (currcar->facing == W) )
				{
					mapx = oldmapx;
					mapy = oldmapy;
				} // end if going into red light
				else
				{
// Check to see if someone else is in the intersection ...
/*
					if( carmap[ (tempmapy*60) + tempmapx ] ) { mapx = oldmapx; mapy = oldmapy; break; }
					if( carmap[ (tempmapy*60) + tempmapx+1 ] ) { mapx = oldmapx; mapy = oldmapy; break; }
					if( carmap[ ((tempmapy+1)*60) + tempmapx ] ) { mapx = oldmapx; mapy = oldmapy; break; }
					if( carmap[ ((tempmapy+1)*60) + tempmapx+1 ] ) { mapx = oldmapx; mapy = oldmapy; break; }
*/
				} // end if trying to go into green light

				break;

			case HORZYELLOW:
			case VERTRED:
				if( currcar->carid == AMBULANCE ) break;

				if( (currcar->facing == N) || (currcar->facing == S) )
				{
					mapx = oldmapx;
					mapy = oldmapy;
				} // end if going into red light
				else
				{
// Check to see if someone else is in the intersection ...
/*
					if( carmap[ (tempmapy*60) + tempmapx ] ) { mapx = oldmapx; mapy = oldmapy; break; }
					if( carmap[ (tempmapy*60) + tempmapx+1 ] ) { mapx = oldmapx; mapy = oldmapy; break; }
					if( carmap[ ((tempmapy+1)*60) + tempmapx ] ) { mapx = oldmapx; mapy = oldmapy; break; }
					if( carmap[ ((tempmapy+1)*60) + tempmapx+1 ] ) { mapx = oldmapx; mapy = oldmapy; break; }
*/
				} // end if trying to go into green light

				break;

			} // end switch on lightsetting

		} // end if isintersection

CheckForCar:

// Check for other car ...
		if( carmap[ (mapy*60) + mapx ] )
		{
/*
			if( (oldmapx == 59) || (oldmapx == 0) || (oldmapy == 59) || (oldmapy == 0) )
			{
				return FALSE;
			} // end if collision at edge of map
*/

			mapx = oldmapx;
			mapy = oldmapy;

//				if( currcar->carid == AMBULANCE )
//				{
//					currcar->speed = 2;
//				} // end if AMBULANCE

		} // end if other car here ...

		} // end new space IS on map ...


// Update cars location ...
		currcar->carmapx = mapx;
		currcar->carmapy = mapy;

		if( (mapx == oldmapx) && (mapy == oldmapy) )
		{
//			warninglevel++;

			if( !currcar->stopped )
			{
				currcar->stopped = 1;
				numofcarsstopped++;
//				warninglevel++;
			}

			if( currcar->carid == AMBULANCE )
			{
//				warninglevel += 5;
			} // end if ambulance


			if( currcar->facing != oldfacing ) // if car was trying to turn
			 currcar->pathno--;

			currcar->facing = oldfacing;

			switch( currcar->facing )
			{
			case N:
				currcar->graphicx = 0;
				currcar->graphicy = 10;
				currcar->xsize = 1;
				currcar->ysize = 2;
				break;
		
			case S:
				currcar->graphicx = 10;
				currcar->graphicy = 10;
				currcar->xsize = 1;
				currcar->ysize = 2;
				break;
		
			case E:
				currcar->graphicx = 0;
				currcar->graphicy = 30;
				currcar->xsize = 2;
				currcar->ysize = 1;
				break;
		
			case W:
				currcar->graphicx = 0;
				currcar->graphicy = 0;
				currcar->xsize = 2;
				currcar->ysize = 1;
				break;

			} // end switch on current facing ...

		} // end if still in same space, don't increase pathno
		else
		{
//			if( warninglevel < 3 ) warninglevel = 0;
//			else warninglevel -= 3;

			if( currcar->stopped )
			{
				currcar->stopped = 0;
				numofcarsstopped--;
			}

			currcar->pathno++;
			currcar->spaceshift = 4;

			if( currcar->carid == AMBULANCE )
			{
//				if( warninglevel < 4 ) warninglevel = 0;
//				else warninglevel -= 4;
			} // end if ambulance

		} // end if in new space


// See if reached goal ...
		if( (mapx == 60) || (mapx == -1) || (mapy == 60) || (mapy == -1) )
		{
// Change score ...
			score += (200*currcar->xsize*currcar->ysize);
			if( currcar->carid == AMBULANCE )
			{
				score += 1600;
				warninglevel -= 400;
				if( warninglevel < 0 ) warninglevel = 0;
				numofcops++;
				if( numofcops == 11 ) numofcops = 10;

				numofcopsonmap--;
			} // end if AMBULANCE



			prevcarptr = (CAR *)currcar->prevcar;
			nextcarptr = (CAR *)currcar->nextcar;

			prevcarptr->nextcar = nextcarptr;
			nextcarptr->prevcar = prevcarptr;

			free( currcar );
			memoryused -= sizeof(CAR);

			numofcars--;

			currcar = nextcarptr;

//			if( warninglevel > 0 ) warninglevel--;



			if( score >= nextlevelat )
			{
				difficulty++;
				nextlevelat += (difficulty*1000);

				if( difficulty == 41 ) difficulty--;

				if( playingcampaign && (difficulty > 20))
				{
					g_response = GAMEWON;
				} // end if playingcampaign and reached level 21

			} // end if raised difficulty

			continue;

		} // end if reached goal



// Show car in carmap ...
		tempmapx = mapx;
		tempmapy = mapy;
		stopped = currcar->stopped + 1;


		switch( currcar->facing )
		{
		case N:
			for( index = 0; index < currcar->ysize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapy >= 60 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = stopped;
				tempmapy++;
			} // end index loop
			break;

		case S:
			for( index = 0; index < currcar->ysize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapy < 0 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = stopped;
				tempmapy--;
			} // end index loop
			break;

		case E:
			for( index = 0; index < currcar->xsize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapx < 0 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = stopped;
				tempmapx--;
			} // end index loop
			break;

		case W:
			for( index = 0; index < currcar->xsize; index++ )
			{
// TODO -- Take out MULT 
				if( tempmapx >= 60 ) break;
				carmap[ (tempmapy*60) + tempmapx ] = stopped;
				tempmapx++;
			} // end index loop
			break;

		} // end switch on facing
		
		currcar = (CAR *)currcar->nextcar;

	} // end loop through all cars


EndUpdateCars:


	return TRUE;
} // end updatecars



int drawcars( void )
{
	int mapx, mapy;

	int screenx, screeny;
	int rightx, bottomy;

	int offset;
//	word *tempscreenptr;
//	word *tempcarptr;

	CAR *currcar;

	byte carwidth, carheight;

//	byte lineindex, bitindex;
//	word pixel;

	HRESULT ddrval;
	RECT rcRect;


	currcar = (CAR *)firstcar.nextcar;

	if( currcar == &lastcar ) goto EndDrawCars;




	for( ;; )
	{
		if( currcar == &lastcar ) break;

		mapx = currcar->carmapx;
		mapy = currcar->carmapy;

		carwidth = times10(currcar->xsize);
		carheight = times10(currcar->ysize);

		screenx = 200L + times10(mapx);
		screeny = times10(mapy);



// Draw car ...

// Adjust screen coordinates for map coordinates being the front of the car ...
// TODO -- Change for different size vehicles ...
		switch( currcar->facing )
		{
		case W:
			break;
		case N:
			break;
		case E:
			screenx -= times10(currcar->xsize-1);
			break;
		case S:
			screeny -= times10(currcar->ysize-1);
			break;

		} // end switch on facing ...


		if( currcar->spaceshift )
		{
			int offset;

			offset = currcar->spaceshift << 1;

			switch( currcar->facing )
			{
			case N:	screeny += offset; break;
			case S:	screeny -= offset; break;
			case E:	screenx -= offset; break;
			case W:	screenx += offset; break;

			} // end switch on facing

		} // end if halfway in space

	rcRect.left = currcar->homex + currcar->graphicx;
	rcRect.top = currcar->homey + currcar->graphicy;


		rightx = screenx + carwidth;
		bottomy = screeny + carheight;

//		tempcarptr = cargraphicptr + ((currcar->homey+currcar->graphicy) << 9) + (currcar->homex+currcar->graphicx);

// Animate for ambulance
		if( currcar->carid == AMBULANCE )
		{
// TODO -- Change to bit shifting!
//			tempcarptr += times20( (tickcount%16)>>2 );
			rcRect.left += times20( (tickcount%16)>>2 );
		} // end if ambulance


// Clip at edges of screen ...
		if( screeny < 0 )
		{
			offset = 0 - screeny;
			screeny = 0;
			
//			tempcarptr += (offset << 9);
			rcRect.top += offset;
			carheight -= offset;

//			if( carheight <= 0 ) goto EndDrawOneCar;
		} // end if screeny < 0

		if( bottomy >= SCREENHEIGHT )
		{
			offset = bottomy - SCREENHEIGHT;
//			bottomy = SCREENHEIGHT;
			
			carheight -= offset;
		} // end if screeny >= SCREENHEIGHT

		if( screenx < 200 )
		{
			offset = 200L - screenx;
			screenx = 200L;
			
//			tempcarptr += offset;
			rcRect.left += offset;
			carwidth -= offset;
		} // end if screenx < 0

		if( rightx >= SCREENWIDTH )
		{
			offset = rightx - SCREENWIDTH;
//			rightx = SCREENWIDTH;
			
			carwidth -= offset;
		} // end if screenx >= SCREENWIDTH


		rcRect.right = rcRect.left + carwidth;
		rcRect.bottom = rcRect.top + carheight;



    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( screenx, screeny, lpDDS[DDS_CARS],
            &rcRect, DDBLTFAST_SRCCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing cars.", ddrval );
			cleanup( OK, NULL );
		}

	} // end loop

/*
		tempscreenptr = g_vsptr + VSOFFSET + times800(screeny) + screenx;

		for( lineindex = 0; lineindex < carheight; lineindex++ )
		{
			for( bitindex = 0; bitindex < carwidth; bitindex++ )
			{
				pixel = *tempcarptr;
				if( pixel ) *tempscreenptr = pixel;

				tempscreenptr++;
				tempcarptr++;
			} // end bitindex loop

			tempscreenptr += SCREENWIDTH - carwidth;
			tempcarptr += 512L - carwidth;

		} // end lineindex loop
*/

EndDrawOneCar:

		currcar = (CAR *)currcar->nextcar;

	} // end loop through ALL cars


EndDrawCars:

	return TRUE;






/*
// Before change to DD Surface ...

	LOCKVS;


	for( ;; )
	{
		if( currcar == &lastcar ) break;

		mapx = currcar->carmapx;
		mapy = currcar->carmapy;

		carwidth = times10(currcar->xsize);
		carheight = times10(currcar->ysize);

		screenx = 200L + times10(mapx);
		screeny = times10(mapy);



// Draw car ...

// Adjust screen coordinates for map coordinates being the front of the car ...
// TODO -- Change for different size vehicles ...
		switch( currcar->facing )
		{
		case W:
			break;
		case N:
			break;
		case E:
			screenx -= times10(currcar->xsize-1);
			break;
		case S:
			screeny -= times10(currcar->ysize-1);
			break;

		} // end switch on facing ...


		if( currcar->spaceshift )
		{
			int offset;

			offset = currcar->spaceshift << 1;

			switch( currcar->facing )
			{
			case N:	screeny += offset; break;
			case S:	screeny -= offset; break;
			case E:	screenx -= offset; break;
			case W:	screenx += offset; break;

			} // end switch on facing

		} // end if halfway in space


		rightx = screenx + carwidth;
		bottomy = screeny + carheight;

		tempcarptr = cargraphicptr + ((currcar->homey+currcar->graphicy) << 9) + (currcar->homex+currcar->graphicx);

// Animate for ambulance
		if( currcar->carid == AMBULANCE )
		{
// TODO -- Change to bit shifting!
			tempcarptr += times20( (tickcount%16)>>2 );
		} // end if ambulance


// Clip at edges of screen ...
		if( screeny < 0 )
		{
			offset = 0 - screeny;
			screeny = 0;
			
			tempcarptr += (offset << 9);
			carheight -= offset;

//			if( carheight <= 0 ) goto EndDrawOneCar;
		} // end if screeny < 0

		if( bottomy >= SCREENHEIGHT )
		{
			offset = bottomy - SCREENHEIGHT;
//			bottomy = SCREENHEIGHT;
			
			carheight -= offset;
		} // end if screeny >= SCREENHEIGHT

		if( screenx < 200 )
		{
			offset = 200L - screenx;
			screenx = 200L;
			
			tempcarptr += offset;
			carwidth -= offset;
		} // end if screenx < 0

		if( rightx >= SCREENWIDTH )
		{
			offset = rightx - SCREENWIDTH;
//			rightx = SCREENWIDTH;
			
			carwidth -= offset;
		} // end if screenx >= SCREENWIDTH



		tempscreenptr = g_vsptr + VSOFFSET + times800(screeny) + screenx;

		for( lineindex = 0; lineindex < carheight; lineindex++ )
		{
			for( bitindex = 0; bitindex < carwidth; bitindex++ )
			{
				pixel = *tempcarptr;
				if( pixel ) *tempscreenptr = pixel;

				tempscreenptr++;
				tempcarptr++;
			} // end bitindex loop

			tempscreenptr += SCREENWIDTH - carwidth;
			tempcarptr += 512L - carwidth;

		} // end lineindex loop


EndDrawOneCar:

		currcar = (CAR *)currcar->nextcar;

	} // end loop through ALL cars


EndDrawCars:

	UNLOCKVS;

	return TRUE;

*/

} // end drawcars



int drawinterface( void )
{
//	word *tempscreenptr;
//	word *temppicptr;
//	int lineindex;

	HRESULT ddrval;

	RECT rcRect;


	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = 200;
	rcRect.bottom = 600;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 0, 0, lpDDS[DDS_INTERFACE],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}



// Draw Interface Bar at Top ...

	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = 600;
	rcRect.bottom = 28;

    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 200, 0, lpDDS[DDS_TOPBAR],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDS[DDS_CITYMAP]->Blt( &rcRect2, lpDDS[DDS_SECTIONS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( MISC, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawcitymap()", ddrval );
			sprintf( tempstr, "(%d,%d) - (%d,%d)", rcRect.left, rcRect.top, rcRect.right, rcRect.bottom );
			cleanup( MISC, tempstr );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}






/* Old way, before using video surface for interface ...

	LOCKVS;

	tempscreenptr = g_vsptr + VSOFFSET;
	temppicptr = interfacegraphicptr;

	for( lineindex = 0; lineindex < SCREENHEIGHT; lineindex++ )
	{
		memcpy( tempscreenptr, temppicptr, 200L*2 );

		temppicptr += 200L;
		tempscreenptr += SCREENWIDTH;
	} // end lineindex loop

	UNLOCKVS;
*/


	return TRUE;

} // end drawinterface


// Also Updates ... Change this ? TODO.
int drawlights( void )
{
	int mapspace;
	int x, y;
	int tempx, tempy;

	word *tempscreenptr;
	word *temppicptr;

	byte lineindex, bitindex;

	int srcx, srcy;
	int destx, desty;

	RECT rcRect;
	HRESULT ddrval;


	mapspace = 0;


	for( y = 0; y < 30; y++ )
	{
		for( x = 0; x < 30; x++ )
		{
			if( lightmap[mapspace] )
			{
				srcy = 600;

				switch( lightmap[mapspace] )
				{
				default:
				case HORZRED:
//					temppicptr = sectionsptr + 160 + times640(600);
					srcx = 160;
					break;
				case VERTRED:
//					temppicptr = sectionsptr + 160 + times640(600) + 40;
					srcx = 160 + 40;
					break;
				case HORZYELLOW:
//					temppicptr = sectionsptr + 160 + times640(600) + 120;
					srcx = 160 + 120;
					break;
				case VERTYELLOW:
//					temppicptr = sectionsptr + 160 + times640(600) + 80;
					srcx = 160 + 80;
					break;
				case COPATLIGHT:
					srcx = 160 + 160;
					break;
				case WRECKATLIGHT:
// Flash Wreck ...
					if( (tickcount - ((tickcount >> 5) << 5)) < 16 )
						srcx = 160 + 200;
					else
						srcx = 160 + 240;

					break;
				} // end switch on which light


				if( overlight == 1 )
				{
					if( (overlightmapx == x) && (overlightmapy == y) &&
						(lightmap[mapspace] != COPATLIGHT) && (lightmap[mapspace] != WRECKATLIGHT) )
					{
						srcx -= 160L;
					} // end if cursor over THIS light

				} // end if cursor is over ANY light ...


//				tempscreenptr = g_vsptr + VSOFFSET + times800((times20(y)-10)) + times20(x) + 200L-10L;
				destx = times20(x) + 200L - 10;
				desty = times20(y) - 10;

	rcRect.left = srcx;
	rcRect.top = srcy;
	rcRect.right = srcx + 40;
	rcRect.bottom = srcy + 40;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( destx, desty, lpDDS[DDS_SECTIONS],
            &rcRect, DDBLTFAST_SRCCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawlights()", ddrval );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast() in drawlights()", ddrval );
		cleanup( OK, NULL );
	}




			} // end if light here

			mapspace++;
		} // end x loop

	} // end y loop


	return TRUE;
} // end drawlights












int rungame( void )
{
	MSG msg;
//	int index;
	CAR *carptr;
//	int blinkrate; // for warninglevel
	BOOL newhiscore;

	HRESULT ddrval;
	RECT rcRect;

	int delta;

	byte oldresponse;

	MUSIC_TIME		musictime;

sprintf( debugstr, "Entering rungame() ...\n" );
WRITETODEBUGFILE;

	pushgamescreen( gamescreen );
	gamescreen = GS_GAME;

	setcursormode( MENUCURSOR );

	score = 0;
	newhiscore = FALSE;


StartRunGame:

	if( playingcampaign == TRUE )
	{
		strcpy( filename, szcampcityname[campcityno] );

		if( loadcitymap( 0 ) == FALSE )
		{
			gamescreen = popgamescreen();
			refreshscreen();
			return FALSE;
		}

		strcpy( cityname, filename+7 );	// Get rid of directory name
		cityname[ strlen(cityname)-4 ] = NULL; // Get rid of extension

		difficulty = 1;
		nextlevelat = score + 1000;

	} // end if playingcampaign
	else
	{
		if( loadcitymap( -1 ) == FALSE )
		{
			gamescreen = popgamescreen();
			refreshscreen();
			return FALSE;
		}

		strcpy( cityname, filename+7 );	// Get rid of directory name
		cityname[ strlen(cityname)-4 ] = NULL; // Get rid of extension

		score = 0;
		difficulty = 1;
		nextlevelat = 1000;

		newhiscore = FALSE;

	} // end if NOT playingcampaign



	drawcitymap();

	numofcars = 0;
	numofcops = 1;
	numofcopsonmap = 0;


sprintf( debugstr, "Calling g_pPerf->PlaySegment() ...\n" );
WRITETODEBUGFILE;

// Start Playing Music ...
	if( g_pPerf && soundon )
	{
		g_pMIDISeg->GetLength( &musictimelength0 );
sprintf( debugstr, "MIDISeg0 Length: %d\n", musictimelength0 );
WRITETODEBUGFILE;
		g_pMIDISeg1->GetLength( &musictimelength1 );
sprintf( debugstr, "MIDISeg1 Length: %d\n", musictimelength1 );
WRITETODEBUGFILE;
		g_pMIDISeg2->GetLength( &musictimelength2 );
sprintf( debugstr, "MIDISeg2 Length: %d\n", musictimelength2 );
WRITETODEBUGFILE;

		g_pMIDISeg3->GetLength( &musictimelength3 );
sprintf( debugstr, "MIDISeg3 Length: %d\n", musictimelength3 );
WRITETODEBUGFILE;

// TESTES! Gonna stretch last song out to same length as other songs ...
		g_pMIDISeg3->SetLength( musictimelength2 );

		g_pMIDISeg3->GetLength( &musictimelength3 );

sprintf( debugstr, "MIDISeg3 Length Set To: %d\n", musictimelength3 );
WRITETODEBUGFILE;


		g_pMIDISeg->SetStartPoint( 0 );
		g_pMIDISeg1->SetStartPoint( 0 );
		g_pMIDISeg2->SetStartPoint( 0 );
		g_pMIDISeg3->SetStartPoint( 0 );

		

		song0playing = TRUE;
		song1playing = FALSE;
		song2playing = FALSE;
		song3playing = FALSE;


		g_pPerf->PlaySegment(g_pMIDISeg, 0, 0, &g_pSegState);

		g_pPerf->GetTime( NULL, &startmusictime );

sprintf( debugstr, "Start Playing Section 0 ... warninglevel: %d, startmusictime: %d\n", warninglevel, startmusictime );
WRITETODEBUGFILE;

	
	}






	g_response = 0xFF;

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive && fullscreen )
				{

//LOCKVS;
//indrawscreen = 1;

if( gamepaused )
{
//	showspriteonce( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 230 );
	showbitmap( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 230 );

	if( (tickcount - ((tickcount >> 6) << 6)) < 32 )
		myfont = EURODARK;
	else
		myfont = EURO;

	centertext( "GAME PAUSED", SCREENHEIGHT/2-20, 0, SCREENWIDTH );
	goto EndMainLoop;
} // end if gamepaused


//			drawcitymap();
			copycitygraphic();

// TESTES ...
			if( tickcount >= checkfornewcarat )
			{
//				int chanceofnewcar;

				checkfornewcarat = tickcount + 10 + checkat[difficulty];

//				chanceofnewcar = 11 - (difficulty>>2);	// 1 in ? (0 - x-1) chance of new car every 1/6 of a second

//				if( rand() % chanceofnewcar == 0 )
//				{
					if( newcar() == FALSE )
					{
						drawcars();
						drawinterface();
						drawlights();

if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();

	    if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 


						okbox( "YOU'RE FIRED!" );

						g_response = FALSE;
						break;
					} // end if player lost
//				}

			} // end if time to check for new car


if( tickgoneby )
{
	tickgoneby = 0;


	updatecars();

/*
			if( updatecars() == FALSE )
			{
				drawcars();
				drawlights();

//				indrawscreen = 0;
//				UNLOCKVS;

if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();

				okbox( "You're Fired!" );
				g_response = FALSE;
				break;
			} // end if player fired
*/


	if( (warninglevel >= 480L*8L) && !godmodeon )
	{
		drawcars();
		drawinterface();
		drawlights();

		if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
		if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();


myfont = EURO;

sprintf( tempstr, "%d", hiscore );
showtextjr( tempstr, 164, 185 );

sprintf( tempstr, "%d", score );
showtextjr( tempstr, 164, 268 );

centertext( cityname, 350, 26, 172 );

sprintf( tempstr, "%d", numofcops );
centertext( tempstr, 409, 107, 154 );


// Show Current Level ...
sprintf( tempstr, "%d", difficulty );
centertext( tempstr, 5, 268, 300 );



// Show Current Level ...
sprintf( tempstr, "%d", difficulty );
centertext( tempstr, 5, 268, 300 );


// Show Warning Level Bar ...

if( warninglevel > 7 )
{
	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = warninglevel >> 3;
	if( rcRect.right > 480 ) rcRect.right = 480;
	rcRect.bottom = 12;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 304, 8, lpDDS[DDS_WARNINGLEVEL],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}

} // end if warninglevel


if( soundon ) lpdsbuffer[SND_GAMEOVER]->Play( NULL, NULL, NULL );

	    if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 

		okbox( "GAME OVER" );

/*
			if( newhiscore )
			{
				drawinterface();


sprintf( tempstr, "%d", hiscore );
showtextjr( tempstr, 164, 185 );

sprintf( tempstr, "%d", score );
showtextjr( tempstr, 164, 268 );

centertext( cityname, 350, 33, 171 );

sprintf( tempstr, "%d", numofcops );
centertext( tempstr, 409, 107, 154 );



// Show Current Level ...
sprintf( tempstr, "%d", difficulty );
centertext( tempstr, 5, 268, 300 );


		if( soundon ) lpdsbuffer[SND_WINGAME]->Play( NULL, NULL, NULL );

		okbox( "New High Score!" );

		if( playingcampaign )
		{
// Re-Save Campaign with new hiscore ...
				sprintf( filename, "campaigns\\%s.cmp", campaignname );

				filehandle = CreateFile( filename,           // create MYFILE.TXT 
				     GENERIC_WRITE,                // open for writing 
					0,                            // do not share 
					NULL,                         // no security 
					CREATE_ALWAYS,                // overwrite existing 
					FILE_ATTRIBUTE_NORMAL |       // normal file 
					FILE_FLAG_OVERLAPPED,         // asynchronous I/O 
					NULL);                        // no attr. template 

				if( filehandle == INVALID_HANDLE_VALUE ) cleanup( NOFILE, filename );

				WriteFile( filehandle, szcampcityname[0], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[1], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[2], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[3], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[4], MAX_PATH+1, &numofbytesread, NULL );

				WriteFile( filehandle, &hiscore, sizeof(hiscore), &numofbytesread, NULL );

				CloseHandle( filehandle );
		} // end if playing campaign

			} // end if new hiscore
*/


		g_response = FALSE;
		break;
	} // end if game over


// Update warning level ...
	delta = 0;


	if( numofcarsstopped )
	{
		if( (numofcarsstopped<<1) >= numofcars )
		{
			delta += numofcarsstopped>>1;
		}
		else
		{
			delta -= ((numofcars>>1) - numofcarsstopped);
		}
	}
	else
	{
		delta -= numofcars >> 1;
	}

	if( delta > 10 ) delta = 10;
	if( delta < -5 ) delta = -5;

	delta += numofcopsstopped<<2;

	warninglevel += delta;


	if( warninglevel < 0 ) warninglevel = 0;

// Change music based on warninglevel ...
	if( g_pPerf && soundon )
	{
/*
		REFERENCE_TIME reftime, reftime2;

		g_pPerf->GetTime( &reftime, NULL );
		g_pPerf->GetResolvedTime( reftime, &reftime2, DMUS_TIME_RESOLVE_MEASURE );

		if( reftime == reftime2 )
		{
*/
		for( ;; )
		{

			if( warninglevel > 480L*6L )
			{
//				if( g_pPerf->IsPlaying( g_pMIDISeg3, g_pSegState3 ) == S_FALSE )
				if( !song3playing )
				{
					g_pPerf->GetTime( NULL, &musictime );
					g_pMIDISeg3->SetStartPoint( (musictime-startmusictime) % musictimelength0 );

//sprintf( debugstr, "Start Playing Section 3 ... warninglevel: %d, musictime: %d\n", warninglevel, musictime );
//WRITETODEBUGFILE;

//					g_pPerf->PlaySegment(g_pMIDISeg3, DMUS_SEGF_MEASURE | DMUS_SEGF_SECONDARY,
					g_pPerf->PlaySegment(g_pMIDISeg3, DMUS_SEGF_SECONDARY, 0, &g_pSegState3);

					song3playing = TRUE;

					g_pPerf->Stop( g_pMIDISeg, NULL, 1, DMUS_SEGF_MEASURE );
					g_pPerf->Stop( g_pMIDISeg1, NULL, 1, DMUS_SEGF_MEASURE );
					g_pPerf->Stop( g_pMIDISeg2, NULL, 1, DMUS_SEGF_MEASURE );

					song0playing = FALSE;
					song1playing = FALSE;
					song2playing = FALSE;

				} // end if not already playing

				break;
			} // end if play overlay 3


			if( warninglevel > 480L*4L )
			{
//				if( g_pPerf->IsPlaying( g_pMIDISeg2, g_pSegState2 ) == S_FALSE )
				if( !song2playing )
				{
					g_pPerf->GetTime( NULL, &musictime );
					g_pMIDISeg2->SetStartPoint( (musictime-startmusictime) % musictimelength0 );

//sprintf( debugstr, "Start Playing Section 2 ... warninglevel: %d, musictime: %d\n", warninglevel, musictime );
//WRITETODEBUGFILE;

					g_pPerf->PlaySegment(g_pMIDISeg2, DMUS_SEGF_SECONDARY, 0, &g_pSegState2);

					song2playing = TRUE;

					g_pPerf->Stop( g_pMIDISeg, NULL, 1, DMUS_SEGF_MEASURE );
					g_pPerf->Stop( g_pMIDISeg1, NULL, 1, DMUS_SEGF_MEASURE );
					g_pPerf->Stop( g_pMIDISeg3, NULL, 1, DMUS_SEGF_MEASURE );

					song0playing = FALSE;
					song1playing = FALSE;
					song3playing = FALSE;

				} // end if not already playing

				break;
			} // end if play overlay 2

			
			if( warninglevel > 480L*2L )
			{
//				if( g_pPerf->IsPlaying( g_pMIDISeg1, g_pSegState1 ) == S_FALSE )
				if( !song1playing )
				{
					g_pPerf->GetTime( NULL, &musictime );
					g_pMIDISeg1->SetStartPoint( (musictime-startmusictime) % musictimelength0 );

//sprintf( debugstr, "Start Playing Section 1 ... warninglevel: %d, musictime: %d\n", warninglevel, musictime );
//WRITETODEBUGFILE;
					g_pPerf->PlaySegment(g_pMIDISeg1, DMUS_SEGF_SECONDARY, 0, &g_pSegState1);

					song1playing = TRUE;

					g_pPerf->Stop( g_pMIDISeg, NULL, 1, DMUS_SEGF_MEASURE );
					g_pPerf->Stop( g_pMIDISeg2, NULL, 1, DMUS_SEGF_MEASURE );
					g_pPerf->Stop( g_pMIDISeg3, NULL, 1, DMUS_SEGF_MEASURE );

					song0playing = FALSE;
					song2playing = FALSE;
					song3playing = FALSE;

				} // end if not already playing

			break;
			} // end if play overlay 1

// If below 1/4 warning level ...
//				if( g_pPerf->IsPlaying( g_pMIDISeg, g_pSegState ) == S_FALSE )
				if( !song0playing )
				{
					g_pPerf->GetTime( NULL, &musictime );
					g_pMIDISeg->SetStartPoint( (musictime-startmusictime) % musictimelength0 );

//sprintf( debugstr, "Start Playing Section 0 ... warninglevel: %d, musictime: %d\n", warninglevel, musictime );
//WRITETODEBUGFILE;
					g_pPerf->PlaySegment(g_pMIDISeg, DMUS_SEGF_SECONDARY, 0, &g_pSegState);

					song0playing = TRUE;

					g_pPerf->Stop( g_pMIDISeg1, NULL, 1, DMUS_SEGF_MEASURE );
					g_pPerf->Stop( g_pMIDISeg2, NULL, 1, DMUS_SEGF_MEASURE );
					g_pPerf->Stop( g_pMIDISeg3, NULL, 1, DMUS_SEGF_MEASURE );

					song1playing = FALSE;
					song2playing = FALSE;
					song3playing = FALSE;

				} // end if not already playing

			break;
	
		} // end infinite loop

//		} // end if on measure
	
	} // end if valid performance pointer and soundon 




// Play Random Sound ...

	if( soundon )
	{

				if( numofcarsstopped > (numofcars>>2) )
				{
					if( rand()%1200 == 0 )
					{
						switch( rand()%2 )
						{
						default:
						case 0:
							lpdsbuffer[SND_CARHORN]->Play( NULL, NULL, NULL );
							break;
						case 1:
							lpdsbuffer[SND_CARHORN2]->Play( NULL, NULL, NULL );
							break;
						}
					} // end if play sound
				} // end if chance for car horn 

				if( numofcarsstopped > (numofcars>>1) )
				{
					if( rand()%1200 == 0 )
					{
						switch( rand()%2 )
						{
						default:
						case 0:
							lpdsbuffer[SND_CARHORN]->Play( NULL, NULL, NULL );
							break;
						case 1:
							lpdsbuffer[SND_CARHORN2]->Play( NULL, NULL, NULL );
							break;
						}
					} // end if play sound
				} // end if chance for car horn 

				if( numofcarsstopped > (numofcars>>1)+(numofcars>>2) )
				{
					if( rand()%1200 == 0 )
					{
						switch( rand()%2 )
						{
						default:
						case 0:
							lpdsbuffer[SND_CARHORN]->Play( NULL, NULL, NULL );
							break;
						case 1:
							lpdsbuffer[SND_CARHORN2]->Play( NULL, NULL, NULL );
							break;
						}
					} // end if play sound
				} // end if chance for car horn 

	} // end if soundon


} // end if tickgoneby (things to do every 1/60th of a second)



			drawcars();

			drawinterface();

			drawlights();



myfont = EURO;


if( fpson )
{
sprintf( tempstr, "DIFFICULTY = %d", difficulty );
centertext( tempstr, 40, 0, 200 );
sprintf( tempstr, "CARS: %d (%d)", numofcars, numofcarsstopped );
centertext( tempstr, 64, 0, 200 );
sprintf( tempstr, "WARNING: %d", warninglevel );
centertext( tempstr, 88, 0, 200 );
}

// Interface Text ...

if( score > hiscore )
{
	hiscore = score;
	newhiscore = TRUE;

} // end if new hiscore

if( newhiscore )
{
	myfont = EURO;
/*
	if( (tickcount - ((tickcount >> 5) << 5)) < 16 )
		myfont = EURODARK;
	else
		myfont = EURO;
*/
}
else myfont = EURODARK;

sprintf( tempstr, "%d", hiscore );
showtextjr( tempstr, 164, 185 );

sprintf( tempstr, "%d", score );
showtextjr( tempstr, 164, 268 );

myfont = EURO;

centertext( cityname, 350, 26, 172 );

sprintf( tempstr, "%d", numofcops );
centertext( tempstr, 409, 107, 154 );


// Show Current Level ...
sprintf( tempstr, "%d", difficulty );
centertext( tempstr, 5, 268, 300 );


// Show Warning Level Bar ...

if( warninglevel > 7 )
{
	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = warninglevel >> 3;
	if( rcRect.right > 480 ) rcRect.right = 480;
	rcRect.bottom = 12;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 304, 8, lpDDS[DDS_WARNINGLEVEL],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}

} // end if warninglevel



#ifdef EDITORS
if( godmodeon )
{
	showtextjr( "G", 800-5, 5 );
} // end if god mode on
#endif

// Do Looping sounds ...


	if( numofcopsonmap )
	{
		if( soundon )
		{
//			if( warninglevel < 2000 )
			if( numofcopsstopped > 1 ) 
			{
				if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
				if( soundon ) lpdsbuffer[SND_COPURGENT]->Play( NULL, NULL, DSBPLAY_LOOPING );
			}
			else if( numofcopsstopped == 1 )
			{
				if( soundon ) lpdsbuffer[SND_COPSIREN]->Play( NULL, NULL, DSBPLAY_LOOPING );
				if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();
			} 

		} // end if soundon

	} // end if cops on screen
	else
	{
		if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
		if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();

		lpdsbuffer[SND_COPSIREN]->SetCurrentPosition( 0 );
		lpdsbuffer[SND_COPURGENT]->SetCurrentPosition( 0 );

	} // end if no cops on screen

	if( numofcopsstopped == 0 )
	{
		if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
		if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();

		lpdsbuffer[SND_COPSIREN]->SetCurrentPosition( 0 );
		lpdsbuffer[SND_COPURGENT]->SetCurrentPosition( 0 );
	} // end if nocops stopped



/*
if( warninglevel > 4000 )
{
// Make it flash!
	if( (tickcount - ((tickcount >> 5) << 5)) < 16 )
	 centertext( "COP NEEDS THROUGH!", 28, 200, SCREENWIDTH );
}
*/

EndMainLoop:

//indrawscreen = 0;
//UNLOCKVS;


					displayscreen();

// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop


	warninglevel = 0;
	numofcarsstopped = 0;
	difficulty = 1;

// Delete cars in linked list ...
	carptr = (CAR *)firstcar.nextcar;

	while( carptr != &lastcar )
	{
		firstcar.nextcar = (CAR *)carptr->nextcar;
		free( carptr );
		memoryused -= sizeof(CAR);
		carptr = (CAR *)firstcar.nextcar;
	} // end while doing cars

	firstcar.nextcar = &lastcar;
	lastcar.prevcar = &lastcar;



if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();


sprintf( debugstr, "g_pPerf->Stop ...\n" );
WRITETODEBUGFILE;
    if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 





	if( newhiscore )
	{
		oldresponse = g_response; // save for other tests

		if( !playingcampaign )
		{
		drawinterface();


sprintf( tempstr, "%d", hiscore );
showtextjr( tempstr, 164, 185 );

sprintf( tempstr, "%d", score );
showtextjr( tempstr, 164, 268 );

centertext( cityname, 350, 26, 172 );

sprintf( tempstr, "%d", numofcops );
centertext( tempstr, 409, 107, 154 );



// Show Current Level ...
sprintf( tempstr, "%d", difficulty );
centertext( tempstr, 5, 268, 300 );


// Show Warning Level Bar ...

if( warninglevel > 7 )
{
	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = warninglevel >> 3;
	if( rcRect.right > 480 ) rcRect.right = 480;
	rcRect.bottom = 12;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 304, 8, lpDDS[DDS_WARNINGLEVEL],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}

} // end if showing warning level bar




		if( soundon ) lpdsbuffer[SND_WINGAME]->Play( NULL, NULL, NULL );




			okbox( "New High Score!" );

// Re-Save city with new hiscore ...
			sprintf( filename, "cities\\%s.cty", cityname );

				filehandle = CreateFile( filename,           // create MYFILE.TXT 
				     GENERIC_WRITE,                // open for writing 
					0,                            // do not share 
					NULL,                         // no security 
					CREATE_ALWAYS,                // overwrite existing 
					FILE_ATTRIBUTE_NORMAL |       // normal file 
					FILE_FLAG_OVERLAPPED,         // asynchronous I/O 
					NULL);                        // no attr. template 

				if( filehandle == INVALID_HANDLE_VALUE ) cleanup( NOFILE, filename );

				WriteFile( filehandle, citymap, 30*30*4, &numofbytesread, NULL );
				WriteFile( filehandle, possiblepath, sizeof(POSSIBLEPATH)*256, &numofbytesread, NULL );

				WriteFile( filehandle, &city, sizeof(CITY), &numofbytesread, NULL );

				WriteFile( filehandle, rotationmap, GRIDWIDTH*GRIDWIDTH, &numofbytesread, NULL );

				WriteFile( filehandle, &hiscore, sizeof(hiscore), &numofbytesread, NULL );

				CloseHandle( filehandle );

		} // end if not playing campaign ...
		else
		{
			if( (g_response == FALSE) || (g_response == TRUE) ) // GAME OVER or QUIT on campaign
			{
		drawinterface();


sprintf( tempstr, "%d", hiscore );
showtextjr( tempstr, 164, 185 );

sprintf( tempstr, "%d", score );
showtextjr( tempstr, 164, 268 );

centertext( cityname, 350, 26, 172 );

sprintf( tempstr, "%d", numofcops );
centertext( tempstr, 409, 107, 154 );



// Show Current Level ...
sprintf( tempstr, "%d", difficulty );
centertext( tempstr, 5, 268, 300 );


// Show Warning Level Bar ...

if( warninglevel > 7 )
{
	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = warninglevel >> 3;
	if( rcRect.right > 480 ) rcRect.right = 480;
	rcRect.bottom = 12;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 304, 8, lpDDS[DDS_WARNINGLEVEL],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}

} // end if showing warning level bar




		if( soundon ) lpdsbuffer[SND_WINGAME]->Play( NULL, NULL, NULL );

			okbox( "New High Score!" );

// Re-Save Campaign with new hiscore ...
				sprintf( filename, "campaigns\\%s.cmp", campaignname );

				filehandle = CreateFile( filename,           // create MYFILE.TXT 
				     GENERIC_WRITE,                // open for writing 
					0,                            // do not share 
					NULL,                         // no security 
					CREATE_ALWAYS,                // overwrite existing 
					FILE_ATTRIBUTE_NORMAL |       // normal file 
					FILE_FLAG_OVERLAPPED,         // asynchronous I/O 
					NULL);                        // no attr. template 

				if( filehandle == INVALID_HANDLE_VALUE ) cleanup( NOFILE, filename );

				WriteFile( filehandle, szcampcityname[0], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[1], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[2], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[3], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[4], MAX_PATH+1, &numofbytesread, NULL );

				WriteFile( filehandle, &hiscore, sizeof(hiscore), &numofbytesread, NULL );

				CloseHandle( filehandle );

			} // end if GAME OVER

		} // end if playing campaign

		g_response = oldresponse;

	} // end if new hiscore 



	if( g_response == GAMEWON )
	{
		campcityno++;

		if( campcityno == 5 )
		{
if( soundon ) lpdsbuffer[SND_WINGAME]->Play( NULL, NULL, NULL );

	    if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 

// TODO -- Change this to better message ...
				drawinterface();


sprintf( tempstr, "%d", hiscore );
showtextjr( tempstr, 164, 185 );

sprintf( tempstr, "%d", score );
showtextjr( tempstr, 164, 268 );

centertext( cityname, 350, 26, 172 );

sprintf( tempstr, "%d", numofcops );
centertext( tempstr, 409, 107, 154 );



// Show Current Level ...
sprintf( tempstr, "%d", difficulty );
centertext( tempstr, 5, 268, 300 );


			okbox( "You win!" );

			if( newhiscore )
			{
				drawinterface();


sprintf( tempstr, "%d", hiscore );
showtextjr( tempstr, 164, 185 );

sprintf( tempstr, "%d", score );
showtextjr( tempstr, 164, 268 );

centertext( cityname, 350, 26, 172 );

sprintf( tempstr, "%d", numofcops );
centertext( tempstr, 409, 107, 154 );



// Show Current Level ...
sprintf( tempstr, "%d", difficulty );
centertext( tempstr, 5, 268, 300 );


		oldresponse = g_response; // save for other tests

		if( soundon ) lpdsbuffer[SND_WINGAME]->Play( NULL, NULL, NULL );

				okbox( "New High Score!" );

// Re-Save Campaign with new hiscore ...
				sprintf( filename, "campaigns\\%s.cmp", campaignname );

				filehandle = CreateFile( filename,           // create MYFILE.TXT 
				     GENERIC_WRITE,                // open for writing 
					0,                            // do not share 
					NULL,                         // no security 
					CREATE_ALWAYS,                // overwrite existing 
					FILE_ATTRIBUTE_NORMAL |       // normal file 
					FILE_FLAG_OVERLAPPED,         // asynchronous I/O 
					NULL);                        // no attr. template 

				if( filehandle == INVALID_HANDLE_VALUE ) cleanup( NOFILE, filename );

				WriteFile( filehandle, szcampcityname[0], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[1], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[2], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[3], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[4], MAX_PATH+1, &numofbytesread, NULL );

				WriteFile( filehandle, &hiscore, sizeof(hiscore), &numofbytesread, NULL );

				CloseHandle( filehandle );


				g_response = oldresponse;

			} // end if new hiscore

			
			rollcredits();


			gamescreen = popgamescreen();
			refreshscreen();

			g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...

			return TRUE;
		} // end if entire campaign beat


if( soundon ) lpdsbuffer[SND_WINGAME]->Play( NULL, NULL, NULL );

	    if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 



		drawinterface();


sprintf( tempstr, "%d", hiscore );
showtextjr( tempstr, 164, 185 );

sprintf( tempstr, "%d", score );
showtextjr( tempstr, 164, 268 );

centertext( cityname, 350, 26, 172 );

sprintf( tempstr, "%d", numofcops );
centertext( tempstr, 409, 107, 154 );



// Show Current Level ...
sprintf( tempstr, "%d", difficulty );
centertext( tempstr, 5, 268, 300 );


// Show Warning Level Bar ...

if( warninglevel > 7 )
{
	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = warninglevel >> 3;
	if( rcRect.right > 480 ) rcRect.right = 480;
	rcRect.bottom = 12;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 304, 8, lpDDS[DDS_WARNINGLEVEL],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}

} // end if showing warning level bar




// Else promote to next city ...
		okbox( "You've been promoted!" );

		goto StartRunGame;

	} // end if campaign city won ...


	if( g_response == NEWCITY )
	{
		goto StartRunGame;
	} // end if campaign city won ...


	gamescreen = popgamescreen();
	refreshscreen();

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...

sprintf( debugstr, "Exiting rungame() ...\n" );
WRITETODEBUGFILE;

	return TRUE;

} // end rungame








int gamemessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
//	int index;
//	int buttonno;
	int mapspace;
	int mapx, mapy;


	switch( message )
	{
	case WM_KEYDOWN:
		if( gamepaused )
		{
			gamepaused = 0;
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );
if( soundon ) lpdsbuffer[SND_PAUSED]->Stop();
			break;
		} // end if gamepaused


		switch( wParam )
		{
		case VK_ESCAPE:
if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();
if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 

			if( confirm( "GIVE UP?" ) )
			{
				g_response = TRUE;
			}
			break;

		case 'P':
			gamepaused ^= 1;
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );


			if( gamepaused )
			{
if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();

if( soundon ) lpdsbuffer[SND_PAUSED]->Play( NULL, NULL, DSBPLAY_LOOPING );
			}

			break;

#ifdef EDITORS
		case 'G':
			godmodeon ^= 1;
			break;

#endif

			break;

		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN


// TODO -- Move this to game handler!

	case WM_LBUTTONDOWN:
		if( gamepaused )
		{
			gamepaused = 0;
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );
if( soundon ) lpdsbuffer[SND_PAUSED]->Stop();
			break;
		} // end if gamepaused



		if( cursorx < 200 )
		{
			if( (cursorx>30) && (cursorx<170) )
			{
				if( (cursory>460) && (cursory<494) )
				{
					soundon ^= 1;

					if( soundon )
					{
						if( g_pPerf )
						{
		g_pMIDISeg->GetLength( &musictimelength0 );
		g_pMIDISeg1->GetLength( &musictimelength1 );
		g_pMIDISeg2->GetLength( &musictimelength2 );
		g_pMIDISeg3->GetLength( &musictimelength3 );
// TESTES! Gonna stretch last song out to same length as other songs ...
		g_pMIDISeg3->SetLength( musictimelength2 );



							g_pMIDISeg->SetStartPoint( 0 );
							g_pMIDISeg1->SetStartPoint( 0 );
							g_pMIDISeg2->SetStartPoint( 0 );
							g_pMIDISeg3->SetStartPoint( 0 );

							g_pPerf->PlaySegment(g_pMIDISeg, 0, 0, &g_pSegState);

							song0playing = TRUE;
							song1playing = FALSE;
							song2playing = FALSE;
							song3playing = FALSE;

							g_pPerf->GetTime( NULL, &startmusictime );

sprintf( debugstr, "Start Playing Section 0 ... warninglevel: %d, startmusictime: %d\n", warninglevel, startmusictime );
WRITETODEBUGFILE;

						}


						lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );
					}


					if( !soundon )
					{
						if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 

						lpdsbuffer[SND_COPSIREN]->Stop();
						lpdsbuffer[SND_COPURGENT]->Stop();
					}



					showbitmap( "bitmaps\\intsound.bmp", 30, 460 );
					displayscreen();
					waitfor( 10 );

				} // end if on PAUSE

				if( (cursory>506) && (cursory<540) )
				{
					gamepaused ^= 1;
					if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

					if( gamepaused )
					{
						if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
						if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();

if( soundon ) lpdsbuffer[SND_PAUSED]->Play( NULL, NULL, DSBPLAY_LOOPING );
					}

					showbitmap( "bitmaps\\intpause.bmp", 30, 506 );
					displayscreen();
					waitfor( 5 );

				} // end if on PAUSE

				if( (cursory>554) && (cursory<588) )
				{
					if( gamepaused )
					{
						gamepaused = 0;
						if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );
						break;
					} // end if gamepaused

					if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

					if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
					if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();

					if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 

					showbitmap( "bitmaps\\intquit.bmp", 30, 554 );
					displayscreen();
					waitfor( 10 );

					if( confirm( "GIVE UP?" ) )
					{
						g_response = TRUE;
					}
					else
					{
						if( soundon )
							if( g_pPerf ) g_pPerf->PlaySegment( g_pMIDISeg, 0, 0, &g_pSegState ); 
					}
					break;
				} // end if on QUIT

				if( (cursory>308) && (cursory<380) )
				{
					if( playingcampaign ) break;


					if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 

					if( soundon ) lpdsbuffer[SND_COPSIREN]->Stop();
					if( soundon ) lpdsbuffer[SND_COPURGENT]->Stop();

					if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

					if( !confirm( "Leave current game?" ) )
					{
						if( soundon )
							if( g_pPerf ) g_pPerf->PlaySegment( g_pMIDISeg, 0, 0, &g_pSegState ); 

						break;
					}


					g_response = NEWCITY;
					break;
				} // end if on CITY NAME



			} // end if in range for buttons

		} // process interface clicks ...




		if( overlight )
		{
			mapspace = (overlightmapy*30) + overlightmapx;

			if( lightmap[mapspace] )
			{
				switch( lightmap[mapspace] )
				{
				case HORZRED:
					lightmap[mapspace] = VERTYELLOW;
					lightwait[mapspace] = lighttickcount+75;
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

					score -= 200 + (difficulty<<4) + (difficulty<<2);
					if( score < 0 ) score = 0;
					break;
				case VERTRED:
					lightmap[mapspace] = HORZYELLOW;
					lightwait[mapspace] = lighttickcount+75;
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

					score -= 200 + (difficulty<<4) + (difficulty<<2);
					if( score < 0 ) score = 0;
					break;
				} // end switch on which way light is pointing ...

			} // end if over light 

			break;

		} // end if is intersection

		break;


	case WM_RBUTTONDOWN:
		if( gamepaused ) break;

		if( numofcops == 0 ) break;

		if( overlight )
		{
			mapspace = (overlightmapy*30) + overlightmapx;

			if( lightmap[mapspace] )
			{
				switch( lightmap[mapspace] )
				{
				case VERTYELLOW:
				case VERTRED:
				case HORZYELLOW:
				case HORZRED:
				case WRECKATLIGHT:
					numofcops--;
					score -= difficulty * 200;
					if( score < 0 ) score = 0;

					lightmap[mapspace] = COPATLIGHT;
					lightwait[mapspace] = lighttickcount+900;
if( soundon ) lpdsbuffer[SND_COPWHISTLE]->Play( NULL, NULL, NULL );
					break;
				} // end switch on which way light is pointing ...

			} // end if over light 

			break;

		} // end if is intersection

		else
		{
			okbox( "Place Cop on traffic light!" );
		} // end if not in intersection

		break; // end case WM_RBUTTONDOWN


	case WM_MOUSEMOVE:
		overlight = 0;

		if( cursorx < 200 ) break;
// TODO -- Take out DIV
		mapy = cursory / 20;
		mapx = (cursorx-200) / 20;

		mapspace = (mapy*30) + mapx;

		if( lightmap[mapspace] )
		{
			overlightmapx = mapx;
			overlightmapy = mapy;
			overlight = 1;

			goto EndCheck;
		} // end if over a light

// Check next block ...
		mapy--;

		if( (mapx >= 0) && (mapx < 30) && (mapy >= 0) && (mapy < 30) )
		{
			mapspace = (mapy*30) + mapx;

			if( lightmap[mapspace] )
			{
				overlightmapx = mapx;
				overlightmapy = mapy;
				overlight = 1;

				goto EndCheck;
			} // end if over a light
		} // end if not off the map ...

// Check next block ...
		mapx++;

		if( (mapx >= 0) && (mapx < 30) && (mapy >= 0) && (mapy < 30) )
		{
			mapspace = (mapy*30) + mapx;

			if( lightmap[mapspace] )
			{
				overlightmapx = mapx;
				overlightmapy = mapy;
				overlight = 1;

				goto EndCheck;
			} // end if over a light
		} // end if not off the map ...

// Check next block ...
		mapy++;

		if( (mapx >= 0) && (mapx < 30) && (mapy >= 0) && (mapy < 30) )
		{
			mapspace = (mapy*30) + mapx;

			if( lightmap[mapspace] )
			{
				overlightmapx = mapx;
				overlightmapy = mapy;
				overlight = 1;

				goto EndCheck;
			} // end if over a light
		} // end if not off the map ...

// Check next block ...
		mapy++;

		if( (mapx >= 0) && (mapx < 30) && (mapy >= 0) && (mapy < 30) )
		{
			mapspace = (mapy*30) + mapx;

			if( lightmap[mapspace] )
			{
				overlightmapx = mapx;
				overlightmapy = mapy;
				overlight = 1;

				goto EndCheck;
			} // end if over a light
		} // end if not off the map ...

// Check next block ...
		mapx--;

		if( (mapx >= 0) && (mapx < 30) && (mapy >= 0) && (mapy < 30) )
		{
			mapspace = (mapy*30) + mapx;

			if( lightmap[mapspace] )
			{
				overlightmapx = mapx;
				overlightmapy = mapy;
				overlight = 1;

				goto EndCheck;
			} // end if over a light
		} // end if not off the map ...

// Check next block ...
		mapx--;

		if( (mapx >= 0) && (mapx < 30) && (mapy >= 0) && (mapy < 30) )
		{
			mapspace = (mapy*30) + mapx;

			if( lightmap[mapspace] )
			{
				overlightmapx = mapx;
				overlightmapy = mapy;
				overlight = 1;

				goto EndCheck;
			} // end if over a light
		} // end if not off the map ...

// Check next block ...
		mapy--;

		if( (mapx >= 0) && (mapx < 30) && (mapy >= 0) && (mapy < 30) )
		{
			mapspace = (mapy*30) + mapx;

			if( lightmap[mapspace] )
			{
				overlightmapx = mapx;
				overlightmapy = mapy;
				overlight = 1;

				goto EndCheck;
			} // end if over a light
		} // end if not off the map ...

// Check next block ...
		mapy--;

		if( (mapx >= 0) && (mapx < 30) && (mapy >= 0) && (mapy < 30) )
		{
			mapspace = (mapy*30) + mapx;

			if( lightmap[mapspace] )
			{
				overlightmapx = mapx;
				overlightmapy = mapy;
				overlight = 1;

				goto EndCheck;
			} // end if over a light
		} // end if not off the map ...



EndCheck:
		if( overlight ) setcursormode( SWITCHCURSOR );
		 else setcursormode( MENUCURSOR );

		break;


	} // end switch on Windows Messages for GS_MAINMENU

	return TRUE;
} // end gamemessagehandler








// Returns filename in filename ... 

int choosefile( BYTE type )
{
	MSG msg;
	int index, index2;

	int listx, listy;

	HANDLE findfilehandle;
	WIN32_FIND_DATA finddata;

	char dirname[MAX_PATH+1];
	char searchparam[8];

	HRESULT ddrval;
	RECT rcRect;

	int numinlist;




	pushgamescreen( gamescreen );
	gamescreen = GS_CHOOSEFILE;

	setcursormode( MENUCURSOR );


	switch( type )
	{
	case CITYFILE:
		strcpy( okboxtext, "CHOOSE CITY" );
		strcpy( dirname, "Cities" );
		strcpy( searchparam, "*.cty" );
		break;
	case CAMPFILE:
		strcpy( okboxtext, "CHOOSE CAMPAIGN" );
		strcpy( dirname, "Campaigns" );
		strcpy( searchparam, "*.cmp" );
		break;
	} // end switch on type


	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = 400;
	rcRect.bottom = 500;

    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 200, 50, lpDDS[DDS_CHOOSEINTERFACE],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( MISC, "restoreAll()" );
			}
			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			cleanup( MISC, "BltFast() in drawing interface" );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( MISC, "BltFast()" );
	}

//	showspriteonce( "bitmaps\\chooseinterface.bmp", 200, 50 );


//		SETTEXTCOLOR(30,24,16);
    myfont = EURO;
    centertext( okboxtext, 70, 0, SCREENWIDTH );

	LoadString( hInst, languageoffset+IDS_CANCEL, string, 256 );
	strcpy( button[0].name, string );

    button[0].x1 = 494;
    button[0].y1 = 504;
    button[0].width = 92;
    button[0].pushed = 0;
//        button[0].color = RGB16(30,24,16);
    button[0].function = BUTTONRETURN;
    button[0].variable = 0;
    button[0].memptr = NULL;
    button[0].glowing = 0;
    button[0].offset = 120;


    drawbutton( 0 );


// Read all filenames from directory ...
	SetCurrentDirectory( dirname );
	numfilesinlist = 0;
	homefileno = 0;

// Get full list of files ... searchparam has been initted with the search parameters (e.g. "*.bmp") ...
	findfilehandle = FindFirstFile( searchparam, &finddata );

// Does this mean no files were found ? I guess not !
		if( findfilehandle == INVALID_HANDLE_VALUE )
		{
			if( GetLastError() == 2 )
			{
				gamescreen = popgamescreen();
				refreshscreen();
				return FALSE;		// FILE NOT FOUND ... is ok, just nothing to display in list
			}

			FindClose( findfilehandle );
			g_response = FALSE;
			MessageBox( hwndmain, "FindFirstFile() failed!", "Error", MB_OK );
			gamescreen = popgamescreen();
			refreshscreen();
			return FALSE;
		} // end if invalid handle returned

		strcpy( tempfilelist[numfilesinlist], finddata.cFileName );
		tempfilelist[numfilesinlist][ strlen(tempfilelist[numfilesinlist])-4 ] = NULL;	// Blank out '.' so no file extension is shown
		numfilesinlist++;


		while( 1 )
		{
			int result;

			result = FindNextFile( findfilehandle, &finddata );

			if( !result )
			{
				if( GetLastError() == ERROR_NO_MORE_FILES ) break;

				FindClose( findfilehandle );
				MessageBox( hwndmain, "FindNextFile() failed!", "Error", MB_OK );
				return 0;
			} // end if error returned

		strcpy( tempfilelist[numfilesinlist], finddata.cFileName );
		tempfilelist[numfilesinlist][ strlen(tempfilelist[numfilesinlist])-4 ] = NULL;	// Blank out '.' so no file extension is shown
		numfilesinlist++;

		} // end loop until no more files are found 

		FindClose( findfilehandle );
		
	SetCurrentDirectory( ".." );


// Sort files alphabetically ...
	strcpy( filelist[0], tempfilelist[0] );
	numinlist = 1;

//sprintf( debugstr, "strcpy( %s, filelist[0] ) \n", tempfilelist[0] );
//WRITETODEBUGFILE;


	for( index = 1; index < numfilesinlist; index++ )
	{
		int result;
		BOOL addedtolist;

		addedtolist = FALSE;

		for( index2 = 0; index2 < numinlist; index2++ )
		{
			result = strcmp( tempfilelist[index], filelist[index2] );

			if( result == 0 ) continue;
			if( result < 0 )
			{
//sprintf( debugstr, "Bump up all lists from %d to %d ... \n", index2, numinlist-1 );
//WRITETODEBUGFILE;

				for( int index3 = numinlist; index3 > index2; index3-- )
				{
					strcpy( filelist[index3], filelist[index3-1] );

				} // end index3 loop

				strcpy( filelist[index2], tempfilelist[index] );

//sprintf( debugstr, "strcpy( filelist[%d], %s ) \n", index2, tempfilelist[index] );
//WRITETODEBUGFILE;

				numinlist++;
				addedtolist = TRUE;

				break;
			} // end if string1 < string2

			if( result > 0 )
			{
				continue;
			} // end if string1 > string2

		} // end index2 loop

		if( !addedtolist )
		{
			strcpy( filelist[index2], tempfilelist[index] );
			numinlist++;

//sprintf( debugstr, "strcpy( filelist[%d], %s ) \n", index2, tempfilelist[index] );
//WRITETODEBUGFILE;

		} // end if NOT addedtolist

	} // end index loop







// List all files ...
	listx = 224;
	listy = 122;

	myfont = EURODARK;


	for( index = 0; index < numfilesinlist; index++ )
	{
		if( index == 12 ) break;

		showtext( filelist[index], listx, listy );
		listy += 30;
	} // end list all files

// Set scroll button position and resolution ...
	scrollypos = 0;

	scrollresolution = 446 - 136;

	if( numfilesinlist > 12 )
	{
		scrollresolution /= ((numfilesinlist+1) - 13);
	} // end if numfilesinlist > 12

	showbitmap( "bitmaps\\scrollbutton.bmp", 570, 136 + scrollypos );



	g_response = 0xFF;

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive && fullscreen )
				{
					drawbutton( 0 );

// Turn cursor off if LMB down on scroll bar ...
/*
		if( (cursorx>565) && (cursorx<590) &&
			(cursory>131) && (cursory<467) && (lmb) )
		{
			setcursormode( CURSOROFF );
		}
		else setcursormode( MENUCURSOR );
*/


					displayscreen();
// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	gamescreen = popgamescreen();
	refreshscreen();

	switch( g_response )
	{
	case TRUE:
		switch( type )
		{
		case CITYFILE:
			sprintf( tempstr, "cities\\%s.cty", filename );

			strcpy( cityname, filename );

			strcpy( filename, tempstr );
			break;
		case CAMPFILE:
			sprintf( tempstr, "campaigns\\%s.cmp", filename );

			strcpy( campaignname, filename );

			strcpy( filename, tempstr );
			break;
		}

		g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...
		return TRUE;

	case FALSE:
		g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...
		return FALSE;

	} 

	return FALSE;

} // end choosefile


int choosefilemessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
	int buttonno;
	int index;
	int listx, listy;


	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = FALSE;

if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

			break;

		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN



	case WM_LBUTTONDOWN:
		if( (cursorx>565) && (cursorx<590) &&
			(cursory>131) && (cursory<467) )
		{
			homefileno = (float)(cursory - 131) / scrollresolution;
			if( homefileno > numfilesinlist-12 ) homefileno = numfilesinlist-12;
			if( numfilesinlist < 13 ) homefileno = 0;
			if( homefileno < 0 ) homefileno = 0;
			scrollypos = (float)homefileno * scrollresolution;

			refreshscreen();
			break;
		} // end if clicked on scroll bar


		if( (cursorx>button[0].x1) && (cursorx<button[0].x1+button[0].width) &&
			(cursory>button[0].y1) && (cursory<button[0].y1+32) )
		{
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = FALSE;
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

			break;
		} // end if pressed on "Cancel" button


		if( (cursorx>565) && (cursorx<591) &&
			(cursory>105) && (cursory<127) )
		{
			showbitmap( "bitmaps\\upscrolldepressed.bmp", 565, 105 );
			displayscreen();
			waitfor( 4 );

			if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

			if( homefileno > 0 )
			{
				homefileno--;
				scrollypos = (float)homefileno * scrollresolution;
			}

			refreshscreen();

			break;
		} // end if pressed on Up Scroll button


		if( (cursorx>565) && (cursorx<591) &&
			(cursory>472) && (cursory<496) )
		{
			showbitmap( "bitmaps\\downscrolldepressed.bmp", 565, 472 );
			displayscreen();
			waitfor( 4 );

			if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

			if( homefileno < numfilesinlist-12 )
			{
				homefileno++;
				scrollypos = (float)homefileno * scrollresolution;
			}

			refreshscreen();

			break;
		} // end if pressed on Down Scroll button



// Check for click on file name
		listx = 224;
		listy = 122;

		for( index = 0; index < numfilesinlist; index++ )
		{
			if( index == 12 ) break;

			if( (cursorx>listx) && (cursorx<listx+320) &&
				(cursory>listy) && (cursory<listy+24) )
				break;

			listy += 30;
		} // end check for file click

		if( (index == numfilesinlist) || (index == 12) ) break;
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

		strcpy( filename, filelist[homefileno + index] );
		g_response = TRUE;
		break;

	case WM_MOUSEMOVE:
		if( (cursorx>565) && (cursorx<590) &&
			(cursory>131) && (cursory<467) && (lmb) )
		{
			homefileno = (float)(cursory - 131) / scrollresolution;
			if( homefileno > numfilesinlist-12 ) homefileno = numfilesinlist-12;
			if( numfilesinlist < 13 ) homefileno = 0;
			if( homefileno < 0 ) homefileno = 0;
			scrollypos = (float)homefileno * scrollresolution;

			refreshscreen();
			displayscreen();
			break;
		} // end if moved with LMB down on scroll bar



		for( buttonno = 0; buttonno < 1; buttonno++ )
		{
			if( (cursorx>button[buttonno].x1) && (cursorx<button[buttonno].x1+button[buttonno].width) &&
				(cursory>button[buttonno].y1) && (cursory<button[buttonno].y1+32) )
			{
				button[buttonno].glowing = 1;
			} // end if cursor on top of button
			else button[buttonno].glowing = 0;

			drawbutton( buttonno );
		} // end buttonno loop

// Check for mouse over file name
		listx = 224;
		listy = 122;

		for( index = 0; index < numfilesinlist; index++ )
		{
			if( index == 12 ) break;

			if( (cursorx>listx) && (cursorx<listx+320) &&
				(cursory>listy) && (cursory<listy+24) )
			{
				myfont = EURO;
			} // end if over file name
			else myfont = EURODARK;

			showtext( filelist[homefileno + index], listx, listy );

			listy += 30;
		} // end check for file click


		break; // end WM_MOUSEMOVE

	case 0x020A: // WM_MOUSEWHEEL
		short int distance;

		distance = (short) HIWORD(wParam);

		if( distance >= 0 )
		{
			if( homefileno > 0 )
			{
				homefileno--;
				scrollypos = (float)homefileno * scrollresolution;
			}

			refreshscreen();
		} // end if moved up 
		else
		{
			if( homefileno < numfilesinlist-12 )
			{
				homefileno++;
				scrollypos = (float)homefileno * scrollresolution;
			}

			refreshscreen();
		} // end if moved down

		break; // end WM_MOUSEWHEEL

	} // end switch on Windows Messages for GS_CHOOSEFILE

	return TRUE;

} // end choose file message handler





void rollcredits( void )
{
	MSG msg;
//	int index;

	dword nextchangeat;
	byte changeto = 1;

	char currtext[120][80];
	int currline;

	int numlines;


	pushgamescreen( gamescreen );
	gamescreen = GS_CREDITS;

	setcursormode( CURSOROFF );


	nextchangeat = tickcount + 30;

	ZeroMemory( currtext[0], 80L*7L );

	strcpy( currtext[0], " " );
	strcpy( currtext[1], " " );
	strcpy( currtext[2], "Rush Hour" );
	strcpy( currtext[3], "(C) 1999  Nothing Special Productions, LLC" );
	strcpy( currtext[4], " " );
	strcpy( currtext[5], " " );

	strcpy( currtext[6], " " );
	strcpy( currtext[7], " " );
	strcpy( currtext[8], "Programming" );
	strcpy( currtext[9], "Everett Bell" );
	strcpy( currtext[10], " " );
	strcpy( currtext[11], " " );

	strcpy( currtext[12], " " );
	strcpy( currtext[13], " " );
	strcpy( currtext[14], "Graphics" );
	strcpy( currtext[15], "Chris Reed" );
	strcpy( currtext[16], " " );
	strcpy( currtext[17], " " );

	strcpy( currtext[18], " " );
	strcpy( currtext[19], " " );
	strcpy( currtext[20], "Design" );
	strcpy( currtext[21], "Esfandiar Mirghahari" );
	strcpy( currtext[22], " " );
	strcpy( currtext[23], " " );

	strcpy( currtext[24], " " );
	strcpy( currtext[25], " " );
	strcpy( currtext[26], "Music" );
	strcpy( currtext[27], "Joshua Cates" );
	strcpy( currtext[28], " " );
	strcpy( currtext[29], " " );

	strcpy( currtext[30], "Beta Testers" );
	strcpy( currtext[31], " " );
	strcpy( currtext[32], "Shane Bell" );
	strcpy( currtext[33], "Kristi Wong" );
	strcpy( currtext[34], "David Wells" );
	strcpy( currtext[35], "Jennifer Wells" );

	strcpy( currtext[36], " " );
	strcpy( currtext[37], " " );
	strcpy( currtext[38], "We would also like to send out" );
	strcpy( currtext[39], "thanks to the following ..." );
	strcpy( currtext[40], " " );
	strcpy( currtext[41], " " );

	strcpy( currtext[42], " " );
	strcpy( currtext[43], "3D Cafe " );
	strcpy( currtext[44], " " );
	strcpy( currtext[45], "For the car and truck models" );
	strcpy( currtext[46], "seen on the main screen" );
	strcpy( currtext[47], " " );

	strcpy( currtext[48], " " );
	strcpy( currtext[49], "The Morgan Real Estate Agency" );
	strcpy( currtext[50], " " );
	strcpy( currtext[51], "For always leaving a light on for us ..." );
	strcpy( currtext[52], "somewhere!" );
	strcpy( currtext[53], " " );

	strcpy( currtext[54], " " );
	strcpy( currtext[55], "The Hickory Center Market" );
	strcpy( currtext[56], " " );
	strcpy( currtext[57], "For letting us run up a tab" );
	strcpy( currtext[58], "(Thanks, guys!)" );
	strcpy( currtext[59], " " );

	strcpy( currtext[60], " " );
	strcpy( currtext[61], " " );
	strcpy( currtext[62], "Joshua Cates uses" );
	strcpy( currtext[63], "Korg Synthesizers" );
	strcpy( currtext[64], " " );
	strcpy( currtext[65], " " );

	strcpy( currtext[66], " " );
	strcpy( currtext[67], " " );
	strcpy( currtext[68], "Everett Bell plays" );
	strcpy( currtext[69], "B.C. Rich Basses" );
	strcpy( currtext[70], " " );
	strcpy( currtext[71], " " );

	strcpy( currtext[72], " " );
	strcpy( currtext[73], " " );
	strcpy( currtext[74], "Chris Reed plays" );
	strcpy( currtext[75], "Jackson Guitars" );
	strcpy( currtext[76], " " );
	strcpy( currtext[77], " " );

	strcpy( currtext[78], " " );
	strcpy( currtext[79], " " );
	strcpy( currtext[80], "Thanks for playing" );
	strcpy( currtext[81], "RUSH HOUR" );
	strcpy( currtext[82], " " );
	strcpy( currtext[83], " " );

	strcpy( currtext[84], " " );
	strcpy( currtext[85], "Check our website at" );
	strcpy( currtext[86], "www.nspgames.com" );
	strcpy( currtext[87], "for other great titles" );
	strcpy( currtext[88], "from NSP Games" );
	strcpy( currtext[89], " " );

	numlines = 90;
	currline = 0;





	refreshscreen();


	if( g_pPerf ) g_pPerf->PlaySegment( g_pMIDISegCredits, 0, 0, &g_pSegState );





	g_response = 0xFF;

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive && fullscreen )
				{
					if( tickcount >= nextchangeat )
					{
						switch( changeto )
						{
						case 0:
							refreshscreen();
// TODO -- Copy in new strings here!
							currline += 6;
							if( currline >= numlines )
							{
								g_response = TRUE;
								break;
							}

							nextchangeat = tickcount + 90;
							changeto = 1;
							break;

						case 1:
							myfont = EURODARK;
							centertext( currtext[currline], 192, 0, SCREENWIDTH );
							centertext( currtext[currline+1], 226, 0, SCREENWIDTH );
							centertext( currtext[currline+2], 260, 0, SCREENWIDTH );
							centertext( currtext[currline+3], 294, 0, SCREENWIDTH );
							centertext( currtext[currline+4], 328, 0, SCREENWIDTH );
							centertext( currtext[currline+5], 362, 0, SCREENWIDTH );
							changeto = 2;
							nextchangeat = tickcount + 3;
							break;

						case 2:
							myfont = EURO;
							centertext( currtext[currline], 192, 0, SCREENWIDTH );
							centertext( currtext[currline+1], 226, 0, SCREENWIDTH );
							centertext( currtext[currline+2], 260, 0, SCREENWIDTH );
							centertext( currtext[currline+3], 294, 0, SCREENWIDTH );
							centertext( currtext[currline+4], 328, 0, SCREENWIDTH );
							centertext( currtext[currline+5], 362, 0, SCREENWIDTH );
							changeto = 3;
							nextchangeat = tickcount + 240;
							break;

						case 3:
							myfont = EURODARK;
							centertext( currtext[currline], 192, 0, SCREENWIDTH );
							centertext( currtext[currline+1], 226, 0, SCREENWIDTH );
							centertext( currtext[currline+2], 260, 0, SCREENWIDTH );
							centertext( currtext[currline+3], 294, 0, SCREENWIDTH );
							centertext( currtext[currline+4], 328, 0, SCREENWIDTH );
							centertext( currtext[currline+5], 362, 0, SCREENWIDTH );
							changeto = 0;
							nextchangeat = tickcount + 3;
							break;

						} // end changeto

					} // end if time to change

					displayscreen();
// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...

    if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 


	gamescreen = popgamescreen();
	refreshscreen();

	return;


} // end rollcredits





int creditsmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{

	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_RETURN:
		case VK_ESCAPE:
			g_response = TRUE;
			break;
		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN


	case WM_LBUTTONDOWN:
		g_response = TRUE;
		if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );
		break;

	} // end switch on Windows Messages for GS_CREDITS


	return TRUE;

} // end creditsmessagehandler




void intro( void )
{
	byte oldcursormode;

	HCURSOR oldhcursor;


	oldhcursor = SetCursor( NULL );


//	fadeinandout( "bitmaps\\xlogo.bmp" );
	fadeinandout( "bitmaps\\nsplogo.bmp" );
//	fadein( "bitmaps\\loading.bmp" );

	showbitmap( "bitmaps\\loading.bmp", 100, 200 );


	oldcursormode = cursormode;
	setcursormode( CURSOROFF );

	displayscreen();

	setcursormode( cursormode );

	SetCursor( oldhcursor );

} // end intro


void fadeinandout( char *bmpfilename )
{
	LPDIRECTDRAWSURFACE4	lpDDSTemp;

	RECT			rcRect;
	DDSURFACEDESC2	ddsd;
	HRESULT			ddrval;


	byte oldcursormode;

	word *srcimageptr;
	word *destimageptr;
	word *tempsrcimageptr;

	float percentage;
	int index;

	int x, y;



	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = 320;
	rcRect.bottom = 240;

	lpDDSTemp = DDLoadBitmapSYS( lpDD4, bmpfilename, 320, 240 );
	if( lpDDSTemp == NULL ) cleanup( NOFILE, bmpfilename );


	srcimageptr = loadandunpackbmp( bmpfilename );




	oldcursormode = cursormode;
	setcursormode( CURSOROFF );

	clearscreen();


// Start fade in loop ...
	for( index = 0; index <= 100; index+=10 )
	{
		word pixel;

		percentage = (float)index / 100.0;


// Lock lpDDSTemp ...
		memset( &ddsd, 0, sizeof(ddsd) );
		ddsd.dwSize = sizeof(ddsd);
		
		ddrval = DDERR_WASSTILLDRAWING;
		
		while( ddrval == DDERR_WASSTILLDRAWING )
		{
			ddrval = lpDDSTemp->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR, NULL );

			if( ddrval == DDERR_SURFACELOST )
			{
				ddrval = restoreAll();
				if( ddrval != DD_OK )
				{
					ShowDDError("restoreAll()", ddrval);
					cleanup( MISC, "Couldn't Lock() Virtual Screen!" );
				} // end if not OK

// TODO -- Check and make sure that I don't need to refresh the VSCREEN here!
//				refreshscreen();
				continue;

			} // end if VSCREEN surface lost
		}

		if( ddrval != DD_OK )
		{
			ShowDDError("Lock()", ddrval);
			cleanup( MISC, "Couldn't Lock() Virtual Screen!" );
		}
		
		destimageptr = (word *)ddsd.lpSurface;
		tempsrcimageptr = srcimageptr;

		for( y = 0; y < 240; y++ )
		{
			for( x = 0; x < 320; x++ )
			{
				pixel = *(tempsrcimageptr);

/*
				int offset;

				offset = (100-index) >> 1;

				if( y & 1 )
				{
					if( tempsrcimageptr > srcimageptr + offset )
					{
						pixel = *(tempsrcimageptr - offset);
					}
					else pixel = *(tempsrcimageptr);
				} // end if y is odd
				else
				{
					if( tempsrcimageptr < srcimageptr - offset + (320L*240L) )
					{
						pixel = *(tempsrcimageptr + offset);
					}
					else pixel = *(tempsrcimageptr);
				} // end if y is even
*/
//			pixel2rgb( pixel );

				rgb16.r = ((pixel & rmask) >> rbitshift);
				rgb16.g = ((pixel & gmask) >> gbitshift);
				rgb16.b = ((pixel & bmask) >> bbitshift);

				rgb16.r = (float)rgb16.r * percentage;
				rgb16.g = (float)rgb16.g * percentage;
				rgb16.b = (float)rgb16.b * percentage;

//			pixel = rgb2pixel;
				pixel = (rgb16.r << rbitshift) | (rgb16.g << gbitshift) | (rgb16.b << bbitshift);

				*destimageptr++ = pixel;
				tempsrcimageptr++;

			} // end x loop

		} // end y loop


// Unlock lpDDSTemp ...
		ddrval = lpDDSTemp->Unlock( NULL );

/*
		if( g_ddrval == DDERR_NOTLOCKED )
		{
			screenlocked = 0;
			return TRUE;
		} // end if VS not locked
*/

		if( ddrval != DD_OK )
		{
			ShowDDError("Unlock()", g_ddrval);
			cleanup( MISC, "Couldn't Unlock() Temp Surface in intro()!" );
		}


// Blit current image ...
	    while( 1 )
		{
	        ddrval = lpDDSVS->BltFast( 240, 180, lpDDSTemp,
				&rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

			if( ddrval == DD_OK ) break;
			if( ddrval == DDERR_SURFACELOST )
			{
				ddrval = restoreAll();
				if( ddrval != DD_OK )
				{
					ShowDDError( "restoreAll()", ddrval );
					cleanup( OK, NULL );
				}

				ddrval = DDReLoadBitmap( lpDDSTemp, bmpfilename );
				if( ddrval != DD_OK )
				{
					ShowDDError( "DDReLoadBitmap() in intro()", ddrval );
					cleanup(OK, NULL );
				} 
	
				continue;
			}
			if( ddrval != DDERR_WASSTILLDRAWING )
			{
				ShowDDError( "BltFast() in intro()", ddrval );
				cleanup( OK, NULL );
			}

		} // end blit loop

		displayscreen();

	} // end fade in loop



// Pause in middle ....
	waitfor( 180 );


// Start fade out loop ...
	for( index = 0; index <= 100; index += 10 )
	{
		word pixel;

		percentage = (float)(100-index) / 100.0;


// Lock lpDDSTemp ...
		memset( &ddsd, 0, sizeof(ddsd) );
		ddsd.dwSize = sizeof(ddsd);
		
		ddrval = DDERR_WASSTILLDRAWING;
		
		while( ddrval == DDERR_WASSTILLDRAWING ) 
		{
			ddrval = lpDDSTemp->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR, NULL );

			if( ddrval == DDERR_SURFACELOST )
			{
				ddrval = restoreAll();
				if( ddrval != DD_OK )
				{
					ShowDDError("restoreAll()", ddrval);
					cleanup( MISC, "Couldn't Lock() Virtual Screen!" );
				} // end if not OK

// TODO -- Check and make sure that I don't need to refresh the VSCREEN here!
//				refreshscreen();
				continue;

			} // end if VSCREEN surface lost
		}

		if( ddrval != DD_OK )
		{
			ShowDDError("Lock()", ddrval);
			cleanup( MISC, "Couldn't Lock() Virtual Screen!" );
		}
		
		destimageptr = (word *)ddsd.lpSurface;
		tempsrcimageptr = srcimageptr;

		for( y = 0; y < 240; y++ )
		{
			for( x = 0; x < 320; x++ )
			{
				pixel = *(tempsrcimageptr);


				int offset;

				offset = index >> 1;

				if( y & 1 )
				{
					if( tempsrcimageptr > srcimageptr + offset )
					{
						pixel = *(tempsrcimageptr - offset);
					}
					else pixel = *(tempsrcimageptr);
				} // end if y is odd
				else
				{
					if( tempsrcimageptr < srcimageptr - offset + (320L*240L) )
					{
						pixel = *(tempsrcimageptr + offset);
					}
					else pixel = *(tempsrcimageptr);
				} // end if y is even

//			pixel2rgb( pixel );

				rgb16.r = ((pixel & rmask) >> rbitshift);
				rgb16.g = ((pixel & gmask) >> gbitshift);
				rgb16.b = ((pixel & bmask) >> bbitshift);

				rgb16.r = (float)rgb16.r * percentage;
				rgb16.g = (float)rgb16.g * percentage;
				rgb16.b = (float)rgb16.b * percentage;

//			pixel = rgb2pixel;
				pixel = (rgb16.r << rbitshift) | (rgb16.g << gbitshift) | (rgb16.b << bbitshift);

				*destimageptr++ = pixel;
				tempsrcimageptr++;

			} // end x loop

		} // end y loop

// Unlock lpDDSTemp ...
		ddrval = lpDDSTemp->Unlock( NULL );

/*
		if( g_ddrval == DDERR_NOTLOCKED )
		{
			screenlocked = 0;
			return TRUE;
		} // end if VS not locked
*/

		if( ddrval != DD_OK )
		{
			ShowDDError("Unlock()", g_ddrval);
			cleanup( MISC, "Couldn't Unlock() Temp Surface in intro()!" );
		}


// Blit current image ...
	    while( 1 )
		{
	        ddrval = lpDDSVS->BltFast( 240, 180, lpDDSTemp,
				&rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

			if( ddrval == DD_OK ) break;
			if( ddrval == DDERR_SURFACELOST )
			{
				ddrval = restoreAll();
				if( ddrval != DD_OK )
				{
					ShowDDError( "restoreAll()", ddrval );
					cleanup( OK, NULL );
				}

				ddrval = DDReLoadBitmap( lpDDSTemp, bmpfilename );
				if( ddrval != DD_OK )
				{
					ShowDDError( "DDReLoadBitmap() in intro()", ddrval );
					cleanup(OK, NULL );
				} 
	
				continue;
			}
			if( ddrval != DDERR_WASSTILLDRAWING )
			{
				ShowDDError( "BltFast() in intro()", ddrval );
				cleanup( OK, NULL );
			}

		} // end blit loop

		displayscreen();

	} // end fade out loop

	lpDDSTemp->Release();

	free( srcimageptr );

	setcursormode( oldcursormode );

} // end fadeinandout





void showorderinfo( void )
{
	showbitmap( "bitmaps\\order.bmp", 0, 0 );

	setcursormode( CURSOROFF );
	displayscreen();

	waitforinput( NULL );

} // end showorderinfo


void waitforinput( int inputtype )
{
	MSG msg;


	pushgamescreen( gamescreen );
	gamescreen = GS_WAITFORINPUT;

	g_response = 0xFF;

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive && fullscreen )
				{
					displayscreen();
// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...


	gamescreen = popgamescreen();

}

