/*
init.cpp
init functions ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "globals.h"


#include <commdlg.h>




int loadgraphics( void )
{
	DDSURFACEDESC2	ddsd;
	HRESULT			ddrval;

	int sectionno;
	int tempx, tempy;


// City Graphics ...
// TODO -- Get rid of THIS!
//	sectionsptr = loadandunpackbmp( "bitmaps\\sections.bmp" );


	tempx = 0;
	tempy = 0;

// 20x20 sections ...

	for( sectionno = 0; sectionno < 32; sectionno++ )
	{
		citysection[sectionno].graphicx = tempx;
		citysection[sectionno].graphicy = tempy;

		citysection[sectionno].xsize = 1;
		citysection[sectionno].ysize = 1;

		tempx += 20;
	} // end sectionno loop

// Intersections ... put traffic lights here ..
	citysection[3].isintersection = 1;
	citysection[4].isintersection = 1;
	citysection[5].isintersection = 1;
	citysection[6].isintersection = 1;
	citysection[7].isintersection = 1;


// 40x40 sections ...
	tempx = 0;
	tempy = 40;

	for( sectionno = 32; sectionno < 48; sectionno++ )
	{
		citysection[sectionno].graphicx = tempx;
		citysection[sectionno].graphicy = tempy;

		citysection[sectionno].xsize = 2;
		citysection[sectionno].ysize = 2;

		tempx += 40;
	} // end sectionno loop

	tempx = 0;
	tempy = 80;

	for( sectionno = 48; sectionno < 64; sectionno++ )
	{
		citysection[sectionno].graphicx = tempx;
		citysection[sectionno].graphicy = tempy;

		citysection[sectionno].xsize = 2;
		citysection[sectionno].ysize = 2;

		tempx += 40;
	} // end sectionno loop



// 80x80 sections ...
	tempx = 0;
	tempy = 120;

	for( sectionno = 64; sectionno < 72; sectionno++ )
	{
		citysection[sectionno].graphicx = tempx;
		citysection[sectionno].graphicy = tempy;

		citysection[sectionno].xsize = 4;
		citysection[sectionno].ysize = 4;

		tempx += 80;
	} // end sectionno loop

	tempx = 0;
	tempy = 200;

	for( sectionno = 72; sectionno < 80; sectionno++ )
	{
		citysection[sectionno].graphicx = tempx;
		citysection[sectionno].graphicy = tempy;

		citysection[sectionno].xsize = 4;
		citysection[sectionno].ysize = 4;

		tempx += 80;
	} // end sectionno loop

	tempx = 0;
	tempy = 280;

	for( sectionno = 80; sectionno < 88; sectionno++ )
	{
		citysection[sectionno].graphicx = tempx;
		citysection[sectionno].graphicy = tempy;

		citysection[sectionno].xsize = 4;
		citysection[sectionno].ysize = 4;

		tempx += 80;
	} // end sectionno loop


	tempx = 0;
	tempy = 360;

	for( sectionno = 88; sectionno < 96; sectionno++ )
	{
		citysection[sectionno].graphicx = tempx;
		citysection[sectionno].graphicy = tempy;

		citysection[sectionno].xsize = 4;
		citysection[sectionno].ysize = 4;

		tempx += 80;
	} // end sectionno loop

	tempx = 0;
	tempy = 440;

	for( sectionno = 96; sectionno < 104; sectionno++ )
	{
		citysection[sectionno].graphicx = tempx;
		citysection[sectionno].graphicy = tempy;

		citysection[sectionno].xsize = 4;
		citysection[sectionno].ysize = 4;

		tempx += 80;
	} // end sectionno loop

	tempx = 0;
	tempy = 520;

	for( sectionno = 104; sectionno < 112; sectionno++ )
	{
		citysection[sectionno].graphicx = tempx;
		citysection[sectionno].graphicy = tempy;

		citysection[sectionno].xsize = 4;
		citysection[sectionno].ysize = 4;

		tempx += 80;
	} // end sectionno loop




// Car Graphics ...
//	cargraphicptr = loadandunpackbmp( "bitmaps\\cars.bmp" );

// Interface Graphic ...
//	interfacegraphicptr = loadandunpackbmp( "bitmaps\\interface.bmp" );

	

/*
// Set aside memory for rendered city graphic ...
	citymapgraphicptr = (word *)calloc( 2, SCREENHEIGHT*SCREENHEIGHT );
	memoryused += SCREENHEIGHT*SCREENHEIGHT*2;
	if( citymapgraphicptr == NULL ) cleanup( OUTOFMEM, "loadgraphics()" );
*/



	currsection = 64;
	
	return TRUE;

} // end loadgraphics



int loadcitymap( int mapno )
{
	int x, y;
	int csno; // city space number

	OPENFILENAME ofn;
	int result;
	char tempfilename[MAX_PATH+1];


sprintf( debugstr, "Entering loadcitymap() ...\n" );
WRITETODEBUGFILE;


// Show dialog box ...
if( mapno == -1 )
{
Start:
	sprintf( filename, "cities\\default.cty" );

	result = choosefile( CITYFILE );

	switch( result )
	{
	case TRUE:
		break; // returned ok
	case FALSE:
		return FALSE; // failed
	} // end switch on result

}

/*	
// TESTES!
// Load city map here ...
	sprintf( filename, "cities\\default.cty" );

	ZeroMemory( &ofn, sizeof(OPENFILENAME) );


	if( mapno == -1 )
	{
		ofn.lStructSize = sizeof( OPENFILENAME );
		ofn.hwndOwner = hwndmain;
//		ofn.lpstrFilter = "Rush Hour Cities\0*.cty\0\0";
		strcpy( tempfilename, "*.cty" );
		ofn.lpstrFile = tempfilename;
		ofn.nMaxFile = MAX_PATH+1;
		ofn.lpstrInitialDir = "cities";
		ofn.Flags = OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;
		ofn.lpstrDefExt = "cty";
		ofn.lpstrTitle = "Load City ...";

		lpDD4->FlipToGDISurface();

		result = GetOpenFileName( &ofn );
		if( result == 0 ) return FALSE;

		strcpy( filename, ofn.lpstrFile );

	} // end if user selected map 

*/


	filehandle = CreateFile( filename,           // open MYFILE.TXT 
                GENERIC_READ,              // open for reading 
                FILE_SHARE_READ,           // share for reading 
                NULL,                      // no security 
                OPEN_EXISTING,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,     // normal file 
                NULL);                     // no attr. template 

	if( filehandle == INVALID_HANDLE_VALUE ) cleanup( NOFILE, filename );

	ReadFile( filehandle, citymap, 30*30*4, &numofbytesread, NULL );
	ReadFile( filehandle, possiblepath, sizeof(POSSIBLEPATH)*256, &numofbytesread, NULL );

	ReadFile( filehandle, &city, sizeof(CITY), &numofbytesread, NULL );

	memset( rotationmap, 0, GRIDWIDTH*GRIDWIDTH ); // In case ReadFile fails ...
	ReadFile( filehandle, rotationmap, GRIDWIDTH*GRIDWIDTH, &numofbytesread, NULL );

	if( !playingcampaign )
	{
		hiscore = 0; // In case ReadFile fails ...
		ReadFile( filehandle, &hiscore, sizeof(hiscore), &numofbytesread, NULL );
	} // only read hiscore from city if NOT playing campaign

	CloseHandle( filehandle );




// Set up traffic lights ...
	ZeroMemory( lightmap, GRIDWIDTH*GRIDWIDTH );
	ZeroMemory( lightwait, GRIDWIDTH*GRIDWIDTH*4 );

	csno = 0;

	for( y = 0; y < GRIDWIDTH; y++ )
	{
		for( x = 0; x < GRIDWIDTH; x++ )
		{
			if( citysection[ citymap[csno] ].isintersection )
			{
				if( rand()%2 ) lightmap[csno] = HORZRED;
				 else lightmap[csno] = VERTRED;

				lightwait[csno] = 0;
			} // end if IS intersection

			csno++;
		} // end x loop

	} // end y loop


	
// Clear carmap ...
	memset( carmap, 0, 60*60*4 );

// Initialize cars ...
	ZeroMemory( &firstcar, sizeof(CAR) );
	ZeroMemory( &lastcar, sizeof(CAR) );

	firstcar.carid = 0;
	firstcar.nextcar = &lastcar;

	lastcar.carid = -1;
	lastcar.prevcar = &firstcar;


sprintf( debugstr, "Exiting loadcitymap() ...\n" );
WRITETODEBUGFILE;


	return TRUE;

} // end loadcitymap
